package net.minecraft.thKaguyaMod;

import net.minecraft.*;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.List;
import java.util.Random;
import net.minecraft.item.ItemStack;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.passive.EntityTameable;
import net.minecraft.entity.monster.EntityGhast;
import net.minecraft.entity.monster.EntityCreeper;
import net.minecraft.item.Item;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagDouble;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;
import net.minecraft.client.audio.SoundManager;

public class EntityPrivateSquare extends Entity
{
	//時間を停止させる空間

	public EntityLivingBase userEntity;
	private int count;
	private int mode;
	private float watchRotation;

    public EntityPrivateSquare(World world)
    {
        super(world);
        preventEntitySpawning = true;
        setSize(0.4F, 0.4F);//サイズを設定　平面上の横と奥行きサイズ、高さ
        yOffset = 0.0F;//高さを設定
    	mode = 2;
    	//count = 0;
    	//watchRotation = 0.0F;
    }
	
	protected void entityInit()
    {
    }
	
	//押すことができるか
    public boolean canBePushed()
    {
        return false;
    }
	
    public EntityPrivateSquare(World world,EntityLivingBase EntityLivingBase, int pmode)
    {
        this(world);

    	userEntity = EntityLivingBase;//使用者をshootingEntityに保存
    	prevPosX = userEntity.posX;
        prevPosY = userEntity.posY;
        prevPosZ = userEntity.posZ;
        setPosition(userEntity.posX - Math.sin((userEntity.rotationYaw + 30.0F) / 180F * 3.141593F),
        			userEntity.posY + (double)userEntity.getEyeHeight() - 0.5D,
        			userEntity.posZ + Math.cos((userEntity.rotationYaw + 30.0F) / 180F * 3.141593F));//初期位置を設定(x,y,z)
    	rotationYaw = userEntity.rotationYaw;
		mode = pmode;
    }

	//他のEntityと衝突するか 右クリックできるかもこれで判定
    public boolean canBeCollidedWith()
    {
        return false;
    }

	//Entityが存在する限り毎フレーム呼び出されるメソッド
    public void onUpdate()
    {
        super.onUpdate();

    	//使用者がいないなら
    	if(!worldObj.isRemote && userEntity == null)
    	{
    		thKaguyaLib.itemEffectFinish(this, userEntity, mod_thKaguya.sakuyawatchItem);
    		return;
    	}
    	
    	if(mode == 1 && ticksExisted > 30)
    	{
    		thKaguyaLib.itemEffectFinish(this, userEntity, mod_thKaguya.sakuyawatchItem);
    	}
    	//使用者がいるなら
    	if(!worldObj.isRemote && userEntity != null)
    	{
    		if(userEntity instanceof EntityPlayer)
    		{
    			EntityPlayer userEntity_p = (EntityPlayer)userEntity;
	    		if(!userEntity_p.capabilities.isCreativeMode)//クリエイティブモードでないなら
	    		{
	    			if(mode <= 1)//時間停止モードなら
	    			{
	    				userEntity_p.addExhaustion(0.25F);//満腹度を大きく減らす
	    			}
	    			else//時間減速モードなら
	    			{
	    				userEntity_p.addExhaustion(0.10F);//満腹度を少し減らす
	    			}
	    		}
    		}
    		if(ticksExisted > 10 && userEntity.isSneaking())//出現から時間が経っていて、使用者がスニークモードなら
    		{
    			thKaguyaLib.itemEffectFinish(this, userEntity, mod_thKaguya.sakuyawatchItem);//終了処理に移る
    		}
    		if(userEntity.hurtTime > 0)//使用者ががダメージを受けたら終了
    		{
    			thKaguyaLib.itemEffectFinish(this, userEntity, mod_thKaguya.sakuyawatchItem);//終了処理に移る
    		}
    	}

    	//世界の時間を止める
    	/*if(mode == 0)
    	{
    		worldObj.worldInfo.setWorldTime(worldObj.worldInfo.getWorldTime() - 1L);
    	}
    	else if(count % 2 == 0)//世界の時間を遅くする
    	{
    		worldObj.worldInfo.setWorldTime(worldObj.worldInfo.getWorldTime() - 1L);
    	}*/


    	thKaguyaLib.itemEffectFollowUser(this, userEntity, 1.2D, 30F);

    	watchRotation = ((float)count * 10.0F) % 360F;
    	/*watchRotation += 10.0F;
    	if(watchRotation > 180F)
    	{
    		watchRotation -= 360F;
    	}*/
    	rotationYaw = watchRotation;
    	/*rotationYaw += 10.0F;
    	if(rotationYaw > 180F)
    	{
    		rotationYaw -= 360F;
    	}*/

    	int playerCount = 0;//停止空間内のプレイヤーの数を数える　誰もいなければ消滅させる
    	
    	//***********停止空間（時計じゃなくてもっと大きな見えない壁）とEntityの当たり判定を取る****************//
    	MovingObjectPosition movingObjectPosition = new MovingObjectPosition(this);
    	Entity entity = null;
    	double effectiveBoundary = 20.0D;//停止空間の有効範囲
    	//停止空間内のEntityを全て取得
    	List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.expand(effectiveBoundary, effectiveBoundary, effectiveBoundary));

        if (list != null && list.size() > 0)//取得したリストにEntityがいるなら
        {
            for (int j1 = 0; j1 < list.size(); j1++)//取得したEntityリストの最初から最後まで見る
            {
                entity = (Entity)list.get(j1);//entityに取得したリストのEntityを代入
            	if (entity != null )//Entityがいるなら
        		{
            		movingObjectPosition = new MovingObjectPosition(entity);//MovingObjectPositionにEntityを登録
        		}
            	if(entity instanceof EntityPlayer)//プレイヤーなら
            	{
            		playerCount++;//範囲内のプレイヤー数カウントを増加
            	}
            	//movingObjectPositionがあり、それが使用者でないなら
        		if (!worldObj.isRemote && movingObjectPosition != null && movingObjectPosition.entityHit != userEntity && movingObjectPosition.entityHit.riddenByEntity != userEntity)
        		{
            		inPrivateSquare(movingObjectPosition);//時間操作空間の処理
        		}
            }
        }

    	if(playerCount == 0)//範囲内にプレイヤーが一人もいなかったなら
    	{
    		if(!worldObj.isRemote)
    		{
    			thKaguyaLib.itemEffectFinish(this, userEntity, mod_thKaguya.sakuyawatchItem);//終了処理に移る
    		}
    	}

        //************************************************************************************//

		count ++;
    	if(count % 20 == 19)//20フレーム周期で音を出す
    	{
    		worldObj.playSoundAtEntity(this, "random.orb", 0.5F, 6.0F);
    		worldObj.playSoundAtEntity(this, "random.click", 0.5F, 4.0F);
    	}
}

    //EntityのデータをNBTに書き込む
    protected void writeEntityToNBT(NBTTagCompound nbttagcompound)
    {
    	nbttagcompound.setShort("count", (short)count);
    }

	//NBTからEntityのデータを読み込む
    protected void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
    	count = nbttagcompound.getShort("count");
    }

    public float getShadowSize()
    {
        return 0.5F;
    }


	//時間操作空間に入っていた時の処理
	protected void inPrivateSquare(MovingObjectPosition movingObjectPosition)
    {
    	Entity hitEntity = (Entity)movingObjectPosition.entityHit;
    	//SoundManager soundManager = new SoundManager();
    	//Entityが誕生してから２フレーム経過したもののみ判定
    	if(hitEntity != null && hitEntity.ticksExisted > 2)
    	{
    		//====時間停止空間の場合====//
    		if(mode <= 1)
    		{
    		//Entityを１フレーム前の状態に、できる限りもっていく処理
	    		hitEntity.setPosition( hitEntity.prevPosX, hitEntity.prevPosY, hitEntity.prevPosZ);
    			//worldObj.removeEntity(movingobjectposition.entityHit);
    			hitEntity.motionX *= 0.000000001;
	    		hitEntity.motionY *= 0.000000001;
	    		hitEntity.motionZ *= 0.000000001;
	    		//movingobjectposition.entityHit.rotationPitch = movingobjectposition.entityHit.prevRotationPitch;
	    		//movingobjectposition.entityHit.rotationYaw = movingobjectposition.entityHit.prevRotationYaw;
    			/*movingobjectposition.entityHit.setLocationAndAngles(	movingobjectposition.entityHit.prevPosX,
    									movingobjectposition.entityHit.posY,
    									movingobjectposition.entityHit.prevPosZ,
    									movingobjectposition.entityHit.rotationPitch,
    									movingobjectposition.entityHit.rotationYaw);*/
	    		hitEntity.ticksExisted--;//誕生してからのカウントを増やさない
	    		hitEntity.fallDistance -= 0.076865F;//落下距離を変動しないように　この値はフレームに比例するが、どこに書いてあるかわからん（一応かなり近い値ではある）
    			if(hitEntity instanceof EntityLivingBase)//範囲内のEntityがEntityLivingBaseに属しているなら
    			{
    				EntityLivingBase EntityLivingBase = (EntityLivingBase)hitEntity;
    				EntityLivingBase.rotationYawHead = EntityLivingBase.prevRotationYawHead;
    			//EntityLivingBase.setAttackTarget(null);
    				//EntityLivingBase.rotationPitchHead = EntityLivingBase.prevRotationPitchHead;
    				/*if(EntityLivingBase.hurtTime > 0)
    				{
    					EntityLivingBase.hurtTime++;
    				}*/
    				/*if(EntityLivingBase.deathTime > 1)
    				{
    					EntityLivingBase.deathTime--;
    				}*/
    				EntityLivingBase.attackTime--;
    				//EntityLivingBase.livingSoundTime--;
    				//EntityLivingBase.setLastAttackingEntity(null);

    				if(EntityLivingBase instanceof EntityCreeper)//EntityCreeperに属しているなら
    				{
    					EntityCreeper entityCreeper = (EntityCreeper)EntityLivingBase;
    					//if(count % 2 == 0)
    					{
    						entityCreeper.setCreeperState(-1);//爆発のカウントを戻す
    					}
    					//entitycreeper.timeSinceIgnited --;
    				}
    				/*else if(EntityLivingBase instanceof EntitySkeleton)
    				{
    					EntitySkeleton entityskeleton = (EntitySkeleton)EntityLivingBase;
    					//entityskeleton.resetTask();
    					entitySkelton.func_48090_aM()
    				}*/
    				else if(EntityLivingBase instanceof EntityGhast)//EntityGhastに属しているなら
    				{
    					EntityGhast entityGhast = (EntityGhast)EntityLivingBase;
    					entityGhast.attackCounter--;//攻撃のカウントを戻す
    				}

    				if(EntityLivingBase instanceof EntityTameable)//テイム可能なら
    				{
    					//EntityTameable entitytameable = (EntityTameable)EntityLivingBase;
    					//if(entitytameable.isTamed())
    					//{
    						EntityLivingBase.motionY-=0.000001D;//座っている動物は重力がなくなると立つみたい　わからない程度に重力をかける処理
    						//entitytameable.motionY-=0.000001D;
    						//entitytameable.func_48140_f(true);
    						//entitytameable.aiSit.func_48407_a(entitytameable.isSitting());
    						//entitytameable.setPathToEntity(null);
    					//}
    					//entitytameable.aiSit.func_48407_a(false);
    				}
    			}
    			//soundManager.stopEntitySound(movingobjectposition.entityHit);
    			
	    		//加速だけは全Entityが処理していないため無理そう　　だから重力の影響を受けるものは扱いにくい
    		}
    		//====時間減速空間の場合====//
    		else//時間を1/2の進みにする
    		{
    			hitEntity.motionX -= (hitEntity.posX-(hitEntity.prevPosX))/2.0F;
    			hitEntity.motionY -= (hitEntity.posY-(hitEntity.prevPosY))/2.0F;
    			hitEntity.motionZ -= (hitEntity.posZ-(hitEntity.prevPosZ))/2.0F;
	    		//movingobjectposition.entityHit.setPosition( movingobjectposition.entityHit.prevPosX,// - movingobjectposition.entityHit.motionX,
	    		//											movingobjectposition.entityHit.prevPosY,// - movingobjectposition.entityHit.motionY,
	    		//											movingobjectposition.entityHit.prevPosZ);// - movingobjectposition.entityHit.motionZ);
	    		//movingobjectposition.entityHit.rotationPitch = movingobjectposition.entityHit.prevRotationPitch;
	    		//movingobjectposition.entityHit.rotationYaw = movingobjectposition.entityHit.prevRotationYaw;
    			hitEntity.fallDistance -= 0.076865F/2F;//落下距離を半減（空中待機時間で変動してしまう）
    			if( count % 2 == 0)//偶数フレームのみ処理
    			{
	    			hitEntity.ticksExisted--;//誕生してからのカウントを増やさない
    				if(hitEntity instanceof EntityLivingBase)
    				{
    					EntityLivingBase EntityLivingBase = (EntityLivingBase)hitEntity;
    					EntityLivingBase.rotationYawHead = EntityLivingBase.prevRotationYawHead;
    				//EntityLivingBase.setLastAttackingEntity(null);

    					if(EntityLivingBase instanceof EntityCreeper)
    					{
    						EntityCreeper entityCreeper = (EntityCreeper)EntityLivingBase;
    						if(count % 2 == 0)
    						{
    							entityCreeper.setCreeperState(-1);
    						}
    						//entitycreeper.timeSinceIgnited --;
    					}
    					else if(EntityLivingBase instanceof EntityGhast)
    					{
    						EntityGhast entityGhast = (EntityGhast)EntityLivingBase;
    						entityGhast.attackCounter--;
    					}
    				}
    			}
	    		//加速だけは全Entityが処理していないため無理そう　　だから重力の影響を受けるものは扱いにくい
    		}
        }
    }

}
