package net.minecraft.thKaguyaMod;

import net.minecraft.*;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.List;
import java.util.Random;
import net.minecraft.item.ItemStack;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagDouble;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public class EntitySpellCard extends Entity
{
	//スペルカード

	public EntityLivingBase userEntity;
	public EntityLivingBase tgEntity;
	public int count;
	private int spellCardNumber;
	Vec3 tgVec;
	private int spellCardUsedTime;

    public EntitySpellCard(World world)
    {
        super(world);
        preventEntitySpawning = true;
        setSize(0.4F, 0.4F);//サイズを設定　平面上の横と奥行きサイズ、高さ
        yOffset = 0.0F;//高さを設定
    }
	
    public EntitySpellCard(World world,EntityLivingBase EntityLivingBase, EntityLivingBase target, int num)
    {
        this(world);

        setPosition(EntityLivingBase.posX - (double)MathHelper.sin((EntityLivingBase.rotationYaw + 30F) / 180F * 3.141593F) * (double)MathHelper.cos(EntityLivingBase.rotationPitch / 180F * 3.141593F),
        			EntityLivingBase.posY - (double)MathHelper.sin(EntityLivingBase.rotationPitch / 180F * 3.141593F) + (double)EntityLivingBase.getEyeHeight() - 0.10000000149011612D ,
        			EntityLivingBase.posZ + (double)MathHelper.cos((EntityLivingBase.rotationYaw + 30F) / 180F * 3.141593F) * (double)MathHelper.cos(EntityLivingBase.rotationPitch / 180F * 3.141593F));//初期位置を設定(x,y,z)
    	rotationYaw = EntityLivingBase.rotationYaw;
    	rotationPitch = EntityLivingBase.rotationPitch;
    	setRotation(rotationYaw, rotationPitch);
    	tgVec = EntityLivingBase.getLookVec();
    	userEntity = EntityLivingBase;//使用者をuserEntityに保存
    	tgEntity = target;//ターゲットした相手
    	spellCardNumber = num;
    	setSpellCardNumber(num);
    	spellCardUsedTime = 0;
    	count = 0;
    	worldObj.playSoundAtEntity(this, "random.spellcard", mod_thKaguya.SpellCardVol, 1.0F);
    }

	//
    protected void entityInit()
    {
    	dataWatcher.addObject(18, new Integer(0));
    }

    /**
     * Returns true if this entity should push and be pushed by other entities when colliding.
     */
    public boolean canBePushed()
    {
        return false;
    }

    /**
     * Returns true if other Entities should be prevented from moving through this Entity.
     */
    public boolean canBeCollidedWith()
    {
    	return false;
    }

	//Entityの消滅処理
	private void finish()
	{
		setDead();
	}
	
	//指定した時間になったらスペルカードを終了する
	private void spellCardEnd(int time)
	{
		if(!worldObj.isRemote && ticksExisted >= time)
		{
			finish();
		}
	}
	
	//Entityが存在する限り毎フレーム呼び出されるメソッド
	@Override
    public void onUpdate()
    {
        super.onUpdate();
    	if(!worldObj.isRemote && (userEntity == null || userEntity.isDead))
    	{
    		setDead();
    	}
    	
    	if(ticksExisted > spellCardUsedTime || spellCardNumber == 8)
    	{
	    	switch(spellCardNumber)
	    	{
	    		case 0://霊符「夢想封印」
	    			spellCard_0();
	    			break;
	    		case 1://恋符「マスタースパーク」
	    			spellCard_1();
	    			break;
	    		case 2://死蝶「華胥の永眠」
	    			spellCard_2();
	    			break;
	    		case 3://星符「メテオニックシャワー」
	    			spellCard_3();
	    			break;
	    		case 4://境符「波と粒の境界」
	    			spellCard_4();
	    			break;
	    		case 5://魍魎「二重黒死蝶」
	    			spellCard_5();
	    			break;
	    		case 6://紅符「スカーレットシュート」
	    			spellCard_6();
	    			break;
	    		case 8://メイド秘技「殺人ドール」
	    			spellCard_8();
	    			break;
	    		case 9://凍符「パーフェクトフリーズ」
	    			spellCard_9();
	    			break;
	    		case 10://幻巣「飛行虫ネスト」
	    			spellCard_10();
	    			break;
	    		case 11://水符「河童のポロロッカ」
	    			spellCard_11();
	    			break;
	    		case 12://魔符「スターダストレヴァリエ」
	    			spellCard_12();
	    			break;
	    		default://
	    			break;
	    	}
    	}
    	
    	if(spellCardUsedTime < ticksExisted)
    	{
    		spellCardUsedTime = ticksExisted;
    	}

		//時間で消滅
		if(ticksExisted >= 200)
		{
			if(!worldObj.isRemote)
			{
				finish();
			}
		}
	}
	
	//霊符「夢想封印」
	private void spellCard_0()
	{
		if(ticksExisted % 2 == 0 && ticksExisted > 15)
		{
			float angle = (float)ticksExisted * 33F;
			double xVec = -(double)MathHelper.sin(angle / 180F * 3.141593F);
			double yVec = 0.0D;
			double zVec = (double)MathHelper.cos(angle / 180F * 3.141593F);
			if(userEntity != null && tgEntity != null)
			{
				EntityMusouFuuin entityMusouFuuin = new EntityMusouFuuin(worldObj, userEntity, xVec, yVec, zVec, 4.0D, 0.0D, 0.1D, 9, rand.nextInt(7), 2.0F, tgEntity);
				if(!worldObj.isRemote)
       			{
        			worldObj.spawnEntityInWorld(entityMusouFuuin);//夢想封印の光弾を出現させる
       			}
			}
		}
		spellCardEnd(49);
	}
	
	//恋符「マスタースパーク」
	private void spellCard_1()
	{
		if(ticksExisted == 1)
		{
			EntityMiniHakkero entityMiniHakkero;
    			
    		entityMiniHakkero = new EntityMiniHakkero(worldObj, userEntity, tgEntity);
       		if(!worldObj.isRemote)
       		{
        			worldObj.spawnEntityInWorld(entityMiniHakkero);//ミニ八卦炉を出す
       		}
		}
		if(ticksExisted > 30)
		{
			EntityTHShot[] entityTHShot = new EntityTHShot[7];
    		double xVector, yVector, zVector, xVectorG, yVectorG, zVectorG, gRate, angleXZ = 0, angleY = 0, X1, Z1, X2, Z2;
			Vec3 lookAt = tgVec;
			lookAt.xCoord = -MathHelper.sin(rotationYaw / 180F * 3.141593F) * MathHelper.cos((rotationPitch + 90F) / 180F * 3.141593F);
    		lookAt.yCoord =	-MathHelper.sin((rotationPitch + 90F) / 180F * 3.141593F);
    		lookAt.zCoord =	 MathHelper.cos(rotationYaw / 180F * 3.141593F) * MathHelper.cos((rotationPitch + 90F) / 180F * 3.141593F);
			lookAt.rotateAroundY((float)Math.PI * 2);
			float angle = (float)ticksExisted * 6F ;
			float angleSpan = 360F / 7F;
			//gRate = (double)(ticksExisted % 9) / 9D + 0.1D;
			gRate = 0.04 + 0.03D * Math.sin(angle / 180F *3.141593F);
			
			xVectorG = -MathHelper.sin(rotationYaw / 180F * 3.141593F) * MathHelper.cos(rotationPitch / 180F * 3.141593F) * gRate;
    		yVectorG = -MathHelper.sin(rotationPitch / 180F * 3.141593F) * gRate;
    		zVectorG =  MathHelper.cos(rotationYaw / 180F * 3.141593F) * MathHelper.cos(rotationPitch / 180F * 3.141593F) * gRate;
			
    		for(int i = 0; i < 7; i++)
    		{
				angleXZ = angle;//横の角度　0=正面　+1ごとに左にずれていき360で正面に戻る
				angleY = 0;//縦の角度　0=正面　+1ごとに上にずれていき360で正面に戻る

				X1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.cos(rotationYaw/ 180.0F * Math.PI);
				Z1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.sin(rotationYaw/ 180.0F * Math.PI);
				X2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((rotationPitch + 90F)/ 180.0F * Math.PI) * Math.sin(rotationYaw/ 180.0F * Math.PI);
				Z2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((rotationPitch + 90F)/ 180.0F * Math.PI) * Math.cos(rotationYaw/ 180.0F * Math.PI);
						
				yVector = -Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin((rotationPitch + 90F - angleY)/ 180.0F * Math.PI);//Y方向　上下
				xVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord + X1 - X2;//X方向　水平方向
				zVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord + Z1 + Z2;//Z方向　水平方向

    			entityTHShot[i] = new EntityTHShot(worldObj, userEntity, this, xVector, yVector, zVector,
    				0.2D, 0.3D, 0.05D, xVectorG, yVectorG, zVectorG, 8, thShotLib.STAR[0] + ticksExisted % 7, 0.8F, 35);
    			angle += angleSpan;
    			if(!worldObj.isRemote)
    			{
    				worldObj.spawnEntityInWorld(entityTHShot[i]);
    			}
    		}
			
			//thShotLib.createCircleShotBaseB(userEntity, this, posX, posY, posZ, rotationYaw + angle, rotationPitch + 90F, 0.2D, 0.3D, 0.05D, xVectorG, yVectorG, zVectorG, 8, thShotLib.STAR[ticksExisted % 7], 0.8F, 35, 0, 7, 0.2D);
		}
		spellCardEnd(99);
	}
	
	//死蝶「華胥の永眠」
	private void spellCard_2()
	{
		if(ticksExisted % 6 == 3)
		{
			//EntityButterflyShot[] entityButterflyShot = new EntityButterflyShot[64];
			EntityTHShot[] entityTHShot = new EntityTHShot[32];
			double X1,X2,Z1,Z2,angleXZ = (double)ticksExisted,angleXZ2, angleY = 0,px, py, pz, vy,vx,vz;
			Vec3 lookAt = userEntity.getLookVec();
			float shootPitch = userEntity.rotationPitch;
			float shootPitchSpan = 360F / 32F;
			lookAt.rotateAroundY((float)Math.PI*2);
			float angle = -30F;
    		float spanAngle = 360F / 32F * 2F;
			int color = 3 + (ticksExisted / 6) % 2;
			//if(color == 1)color = 3;
			color += thShotLib.BUTTERFLY[thShotLib.RED];
			
			//for(int j = 0; j < 8; j++)
			{
	    		for(int i = 0; i < 32; i+=2)
	    		{		
	    			//飛ぶ方向を設定
					angleXZ = angle;//横の角度　0=正面　+1ごとに左にずれていき360で正面に戻る
	    			angleXZ2 = angleXZ + 60F;
					angleY = 0;//縦の角度　0=正面　+1ごとに上にずれていき360で正面に戻る
	    			
					X1 =  Math.sin(angleXZ2 / 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z1 =  Math.sin(angleXZ2 / 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					X2 =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z2 =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
	    			vy = -Math.cos(angleXZ2/ 180.0F * Math.PI) * Math.sin((shootPitch - angleY)/ 180.0F * Math.PI);//Y方向　上下
					vx =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord + X1 - X2;//X方向　水平方向
					vz =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord + Z1 + Z2;//Z方向　水平方向
					
	    			X1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					X2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
	    			py = userEntity.posY - Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin((shootPitch - angleY)/ 180.0F * Math.PI) * 2.0D;//Y方向　上下
					px = userEntity.posX + Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord * 2.0D + X1 - X2;//X方向　水平方向
					pz = userEntity.posZ + Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord * 2.0D + Z1 + Z2;//Z方向　水平方向
	    			
	    			//entityButterflyShot[i] = new EntityButterflyShot(worldObj, userEntity, userEntity, px, py, pz, vx, vy, vz, 0.1D, 0.2D, 0.01D, 6, color, 0.2F);//蝶弾の配列に方向、色などを代入
	    			entityTHShot[i] = new EntityTHShot(worldObj, userEntity, userEntity, px, py, pz, vx, vy, vz, 0.1D, 0.2D, 0.01D, 0.0D, 0.0D, 0.0D, 5, color, 0.6F, 60);//蝶弾の配列に方向、色などを代入
	    			
	    			angleXZ2 = angleXZ - 60F;
	    			
	    			X1 =  Math.sin(angleXZ2 / 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z1 =  Math.sin(angleXZ2 / 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					X2 =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z2 =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
	    			vy = -Math.cos(angleXZ2/ 180.0F * Math.PI) * Math.sin((shootPitch - angleY)/ 180.0F * Math.PI);//Y方向　上下
					vx =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord + X1 - X2;//X方向　水平方向
					vz =  Math.cos(angleXZ2 / 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord + Z1 + Z2;//Z方向　水平方向
					
	    			X1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					X2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
					Z2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin((shootPitch)/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
	    			py = userEntity.posY - Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin((shootPitch - angleY)/ 180.0F * Math.PI) * 2.0D;//Y方向　上下
					px = userEntity.posX + Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord * 2.0D + X1 - X2;//X方向　水平方向
					pz = userEntity.posZ + Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord * 2.0D + Z1 + Z2;//Z方向　水平方向
	    			
	    			//entityButterflyShot[i + 1] = new EntityButterflyShot(worldObj, userEntity, userEntity, px, py, pz, vx, vy, vz, 0.1D, 0.2D, 0.01D, 6, color, 0.2F);//蝶弾の配列に方向、色などを代入
	    			entityTHShot[i + 1] = new EntityTHShot(worldObj, userEntity, userEntity, px, py, pz, vx, vy, vz, 0.1D, 0.2D, 0.01D, 0.0D, 0.0D, 0.0D, 6, color, 0.6F, 70);//蝶弾の配列に方向、色などを代入
					
	    			angle += spanAngle;//飛ばす方向を360/弾数分増やす
				}
				if(!worldObj.isRemote)
	    		{
	    			for(int i = 0; i < 32; i++)
	    			{
	    				//worldObj.spawnEntityInWorld(entityButterflyShot[i]);
	    				worldObj.spawnEntityInWorld(entityTHShot[i]);
	    			}
	    		}
				//shootPitch += shootPitchSpan;
			}
		}
		spellCardEnd(90);
	}
	
	//星符「メテオニックシャワー」
	private void spellCard_3()
	{
		if(!worldObj.isRemote && ticksExisted > 10)
		{
			EntityTHShot entityTHShot;
			double vectorX, vectorY, vectorZ;
			Random rand = new Random();
			int colors[] = {0, 2, 3, 4};
			int color = colors[rand.nextInt(4)] + thShotLib.STAR[0];
			float size = 0.3F + rand.nextFloat() * 0.5F;
			int damage = (int)(size * 10F);
			float yaw = userEntity.rotationYaw + rand.nextFloat() * 20F - 10F;
			float pitch = userEntity.rotationPitch + rand.nextFloat() * 20F - 10F;
			thShotLib.createShotBaseB(userEntity, this, userEntity.posX, userEntity.posY + (double)userEntity.getEyeHeight() - 0.2D, userEntity.posZ, yaw, pitch, 0.1D, 2.0D, 0.1D, 0.0D, 0.0D, 0.0D, damage, color, size, 120, 0);
		}
		spellCardEnd(40);
	}
	
	//境符「波と粒の境界」
	private void spellCard_4()
	{
		if(ticksExisted < 5)
		{
			return;
		}
		rotationYaw += MathHelper.cos((float)ticksExisted / 30F) * 10F;
		rotationPitch = MathHelper.sin(MathHelper.sin(ticksExisted / 10F) * 3.14F) * 10F;
		int color = thShotLib.LIGHT[thShotLib.PURPLE];
		float size = 0.2F;
		int damage = 5;

		thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, rotationYaw, rotationPitch, 0.01D, 0.2D, 0.1D, 0.0D, 0.0D, 0.0D,
										damage, color, size, 100, 0, 7, 0.5D);
		/*thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, rotationYaw, rotationYaw + 90F, 0.01D, 0.2D, 0.1D, 0.0D, 0.0D, 0.0D,
										damage, color, size, 50, 0, 5, 0.5D);
		thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, rotationYaw + 90F, rotationYaw + 90F, 0.01D, 0.2D, 0.1D, 0.0D, 0.0D, 0.0D,
										damage, color, size, 50, 0, 5, 0.5D);
		*///userEntity.motionX = 0.0D;
		//userEntity.motionY = 0.0D;
		//userEntity.motionZ = 0.0D;
		spellCardEnd(160);
	}
	
	//魍魎「二重黒死蝶」
	private void spellCard_5()
	{
		if(ticksExisted % 70 == 10)
		{
			for(int i = 0; i < 30; i++)
			{
				double speed;
				float angleXZ, angleY;
				
				speed = rand.nextDouble() * 2.0 + 0.5D;
				angleXZ = rand.nextFloat() * 360F;
				angleY = rand.nextFloat() * 180F - 90F;
				double vectorX, vectorY, vectorZ;
				vectorX = -Math.sin(angleXZ / 180F * (float)Math.PI) * Math.cos(angleY / 180F * (float)Math.PI);
				vectorY = -Math.sin(angleY / 180F * (float)Math.PI);
				vectorZ =  Math.cos(angleXZ / 180F * (float)Math.PI) * Math.cos(angleY / 180F * (float)Math.PI);
				thShotLib.createCircleShot21(userEntity, angleXZ, angleY, vectorX, vectorY, vectorZ, speed, 0.0D, 0.0D, thShotLib.BUTTERFLY[i % 2], 6, thShotLib.KOKUSHI01, 8);
			}
		}
		spellCardEnd(100);
	}
	
	//紅符「スカーレットシュート」
	private void spellCard_6()
	{
		if(!worldObj.isRemote && ticksExisted % 25 == 20 && ticksExisted < 60)
		{
	    	double xVector, yVector, zVector, xVectorG, yVectorG, zVectorG, gRate, angleXZ = 0, angleY = 0, X1, Z1, X2, Z2;
			Vec3 lookAt = userEntity.getLookVec();
			/*Vec3 lookAt = tgVec;
			lookAt.xCoord = -MathHelper.sin(userEntity.rotationYaw / 180F * 3.141593F) * MathHelper.cos(userEntity.rotationPitch / 180F * 3.141593F);
	    	lookAt.yCoord =	-MathHelper.sin(userEntity.rotationPitch / 180F * 3.141593F);
	    	lookAt.zCoord =	 MathHelper.cos(userEntity.rotationYaw / 180F * 3.141593F) * MathHelper.cos(userEntity.rotationPitch / 180F * 3.141593F);*/
			lookAt.rotateAroundY((float)Math.PI * 2);
			float angle = -90F ;
			float angleSpan = 180F / 4F;
			
	    	for(int i = 0; i < 5; i++)
	    	{
				angleXZ = angle;//横の角度　0=正面　+1ごとに左にずれていき360で正面に戻る
				angleY = 0;//縦の角度　0=正面　+1ごとに上にずれていき360で正面に戻る

				X1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
				Z1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
				X2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin(userEntity.rotationPitch/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
				Z2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin(userEntity.rotationPitch/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
						
				yVector = -Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin((userEntity.rotationPitch - angleY)/ 180.0F * Math.PI);//Y方向　上下
				xVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord + X1 - X2;//X方向　水平方向
				zVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord + Z1 + Z2;//Z方向　水平方向
	    		scarletShot(xVector, yVector, zVector);
	    		angle += angleSpan;
	    	}
		}
		else if(ticksExisted == 80)
		{
			double xVector, yVector, zVector, xVectorG, yVectorG, zVectorG, gRate, angleXZ = 0, angleY = 0, X1, Z1, X2, Z2;
			Vec3 lookAt = userEntity.getLookVec();
			/*Vec3 lookAt = tgVec;
			lookAt.xCoord = -MathHelper.sin(userEntity.rotationYaw / 180F * 3.141593F) * MathHelper.cos(userEntity.rotationPitch / 180F * 3.141593F);
	    	lookAt.yCoord =	-MathHelper.sin(userEntity.rotationPitch / 180F * 3.141593F);
	    	lookAt.zCoord =	 MathHelper.cos(userEntity.rotationYaw / 180F * 3.141593F) * MathHelper.cos(userEntity.rotationPitch / 180F * 3.141593F);*/
			lookAt.rotateAroundY((float)Math.PI * 2);
			float angle = -3F ;
			float angleSpan = 6F / 2F;
			
	    	for(int i = 0; i < 3; i++)
	    	{
				angleXZ = angle;//横の角度　0=正面　+1ごとに左にずれていき360で正面に戻る
				angleY = 0;//縦の角度　0=正面　+1ごとに上にずれていき360で正面に戻る

				X1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
				Z1 =  Math.sin(angleXZ/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
				X2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin(userEntity.rotationPitch/ 180.0F * Math.PI) * Math.sin(userEntity.rotationYaw/ 180.0F * Math.PI);
				Z2 =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin(angleY/ 180.0F * Math.PI) * Math.sin(userEntity.rotationPitch/ 180.0F * Math.PI) * Math.cos(userEntity.rotationYaw/ 180.0F * Math.PI);
						
				yVector = -Math.cos(angleXZ/ 180.0F * Math.PI) * Math.sin((userEntity.rotationPitch - angleY)/ 180.0F * Math.PI);//Y方向　上下
				xVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.xCoord + X1 - X2;//X方向　水平方向
				zVector =  Math.cos(angleXZ/ 180.0F * Math.PI) * Math.cos(angleY/ 180.0F * Math.PI) * lookAt.zCoord + Z1 + Z2;//Z方向　水平方向
	    		scarletShot(xVector, yVector, zVector);
	    		angle += angleSpan;
	    	}
		}
		spellCardEnd(90);
	}
	
	//スカーレットシュートのまとまった弾
	private void scarletShot(double vectorX, double vectorY, double vectorZ)
	{
		EntityTHShot entityTHShot;
		double speed = 1.0D;
		entityTHShot = new EntityTHShot(worldObj, userEntity, vectorX, vectorY, vectorZ, 1.0D, 6, 240, 1.2F);
		if(!worldObj.isRemote)
		{
			worldObj.spawnEntityInWorld(entityTHShot);
		}
		for(int i = 0; i < 11; i++)
		{
			speed = 0.5D + rand.nextDouble() * 0.3D;
			entityTHShot = new EntityTHShot(worldObj, userEntity, 
				vectorX + (rand.nextDouble() - 0.5D) * 0.2D,
				vectorY + (rand.nextDouble() - 0.5D) * 0.2D,
				vectorZ + (rand.nextDouble() - 0.5D) * 0.2D,
				speed, 4, 0, 0.6F);
			if(!worldObj.isRemote)
			{
				worldObj.spawnEntityInWorld(entityTHShot);
			}
		}
		for(int i = 0; i < 22; i++)
		{
			speed = 0.2D + rand.nextDouble() * 0.3D;
			entityTHShot = new EntityTHShot(worldObj, userEntity, 
				vectorX + (rand.nextDouble() - 0.5D) * 0.3D,
				vectorY + (rand.nextDouble() - 0.5D) * 0.3D,
				vectorZ + (rand.nextDouble() - 0.5D) * 0.3D,
				speed, 2, 0, 0.3F);
			if(!worldObj.isRemote)
			{
				worldObj.spawnEntityInWorld(entityTHShot);
			}
		}
		
	}
	
	//メイド秘技「殺人ドール」
	private void spellCard_8()
	{
		if(ticksExisted < 5)
		{
			return;
		}
		else if(ticksExisted >= 23)
		{
			ticksExisted ++;
		}
		
		if(ticksExisted < 15 && ticksExisted % 2 == 0)
		{
			int way = 9;
			float angleXZ = userEntity.rotationYaw + (float)ticksExisted * 10F;
			//float angleY = -90;
			float angleY = userEntity.rotationPitch;
			float spanAngleY = 180F / (way-1);
			float spanAngleXZ = 360F / (float)way / 5F;

			double speed = 0.3D;
			rotationPitch = -60F;
			for(int j = 0; j < 5; j++)
			{
				//thShotLib.createCircleShot01(userEntity, angleXZ, rotationPitch, speed, thShotLib.KNIFE[thShotLib.BLUE], way);
				thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, angleXZ, rotationPitch, 
						speed, speed, 1.0D, 0.0D, 0.0D, 0.0D, 12, thShotLib.KNIFE[thShotLib.BLUE], 0.6F, 80, 0, way, 0.3D);
				angleXZ+= spanAngleXZ;
				rotationPitch += 30F;
				speed -= 0.01D;
			}
			angleY += spanAngleY;
		}
		if(ticksExisted > 14 && ticksExisted < 24 && ticksExisted % 4 == 0)
		{
			int way = 9;
			float angleXZ = userEntity.rotationYaw;
			float angleY = userEntity.rotationPitch;
			//thShotLib.createCircleShot01(userEntity, angleXZ,      angleY, 0.4D, thShotLib.KNIFE[thShotLib.RED], way);
			//thShotLib.createCircleShot01(userEntity, angleXZ + 5F, angleY, 0.4D, thShotLib.KNIFE[thShotLib.RED], way);
			thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, angleXZ, angleY, 
					0.4D, 0.4D, 1.0D, 0.0D, 0.0D, 0.0D, 12, thShotLib.KNIFE[thShotLib.RED], 0.6F, 80, 0, way, 0.3D);
			thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, angleXZ + 5F, angleY, 
					0.4D, 0.4D, 1.0D, 0.0D, 0.0D, 0.0D, 12, thShotLib.KNIFE[thShotLib.RED], 0.6F, 80, 0, way, 0.3D);
		}
		if(ticksExisted == 30)
		{
			boolean flag = true;
		    List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, this.boundingBox.addCoord(0.0D, 0.0D, 0.0D).expand(20.0D, 20.0D, 20.0D));
    		for(int k = 0; k < list.size(); k++)
    		{
    			Entity entity = (Entity)list.get(k);
    			if(entity instanceof EntityPrivateSquare)
    			{
    				EntityPrivateSquare entityPrivateSquare = (EntityPrivateSquare)entity;
    				if(entityPrivateSquare.userEntity == userEntity)
    				{
						flag = false;
    				}
    			}
    		}
			if(flag)
			{
    			EntityPrivateSquare entityPrivateSquare = new EntityPrivateSquare(worldObj, userEntity, 1);
				if(!worldObj.isRemote)
       			{
         			worldObj.spawnEntityInWorld(entityPrivateSquare);//時間停止空間を生み出す
       			}
			}
		}
		if(ticksExisted > 30 && ticksExisted < 54 && ticksExisted % 8 == 3)
		{
			List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, this.boundingBox.addCoord(0.0D, 0.0D, 0.0D).expand(20.0D, 20.0D, 20.0D));
    		for(int k = 0; k < list.size(); k++)
    		{
    			Entity entity = (Entity)list.get(k);
    			if(entity instanceof EntityTHShot)
    			{
    				EntityTHShot entityTHShot = (EntityTHShot)entity;
    				if( (entityTHShot.color == thShotLib.KNIFE[thShotLib.BLUE] || entityTHShot.color == thShotLib.KNIFE[thShotLib.RED] )&& rand.nextInt(100) < 25)
    				{
    					//thShotLib.createShot03(userEntity, entityTHShot.posX, entityTHShot.posY - ((double)userEntity.getEyeHeight() - 0.25D), entityTHShot.posZ, 
    						//	rand.nextFloat() * 360F, rand.nextFloat() * 360F, 0.01D, 0.28D, 0.05D, thShotLib.KNIFE[thShotLib.GREEN]);
    					thShotLib.createShotBaseB(userEntity, userEntity, entityTHShot.posX, entityTHShot.posY - ((double)userEntity.getEyeHeight() - 0.25D), entityTHShot.posZ, 
    							rand.nextFloat() * 360F, rand.nextFloat() * 360F, 0.01D, 0.28D, 0.05D, 0.0D, 0.0D, 0.0D,
    							12, thShotLib.KNIFE[thShotLib.GREEN], 0.6F, 80, 0);
    					entityTHShot.setDead();
    					
    				}
    			}
    		}
		}
		spellCardEnd(70);
	}
	
	//凍符「パーフェクトフリーズ」
	private void spellCard_9()
	{
		if(ticksExisted < 5)
		{
			return;
		}
		
		if(ticksExisted < 38)
		{
			for(int i = 0; i < 6; i++)
			{
				thShotLib.createShot01(userEntity, rand.nextFloat() * 360F, rand.nextFloat() * 360F, 0.5D, thShotLib.CIRCLE[rand.nextInt(7)]);
			}
		}

		if(ticksExisted == 40)
		{
			List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, this.boundingBox.addCoord(0.0D, 0.0D, 0.0D).expand(20.0D, 20.0D, 20.0D));
    		for(int k = 0; k < list.size(); k++)
    		{
    			Entity entity = (Entity)list.get(k);
    			if(entity instanceof EntityTHShot && entity instanceof EntityTHLaser == false)
    			{
    				if(entity instanceof EntityHomingAmulet == false && entity instanceof EntityMusouFuuin == false)
    				{
    					EntityTHShot entityTHShot = (EntityTHShot)entity;
    					EntityTHShot newEntityTHShot;
    					int color = entityTHShot.color - entityTHShot.color % 8 + 7;
    					newEntityTHShot = thShotLib.createShot44(	userEntity, entityTHShot.posX, entityTHShot.posY - ((double)userEntity.getEyeHeight() - 0.25D), entityTHShot.posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F,
    						0.0001D, 0.0001D, 0.0D, entityTHShot.shotDamage, color, entityTHShot.getShotSize(), entityTHShot.deadTime - entityTHShot.ticksExisted + 50, thShotLib.FREEZE01);
    					entityTHShot.setDead();
    				}
    			}
    		}
		}
		spellCardEnd(70);
	}
	
	//幻巣「飛行虫ネスト」
	private void spellCard_10()
	{
		boolean flag = false;
		int count = 0;
		while(!flag && count < 4)
		{
			double length = rand.nextDouble() * 5.0D + 1.0D;
			float angleXZ = (rotationYaw + 90F) / 180F * (float)Math.PI + rand.nextFloat() * (float)Math.PI;
			float angleY  = rand.nextFloat() * (float)Math.PI - (float)Math.PI / 2.0F;
			double xVector = Math.sin(angleXZ) * Math.cos(angleY) * length;
			double yVector = Math.sin(angleY) * length;
			double zVector = Math.cos(angleXZ) * Math.cos(angleY) * length;
			double xPos, yPos, zPos;
		    //始点（現在地）
	    	Vec3 vec3d = worldObj.getWorldVec3Pool().getVecFromPool(userEntity.posX, userEntity.posY, userEntity.posZ);
	    	//終点（現在地に移動量を足した点）
	    	Vec3 vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(userEntity.posX + xVector, userEntity.posY + yVector, userEntity.posZ + zVector);
	        //始点と終点からブロックとの当たりを取得
	    	MovingObjectPosition movingObjectPosition = worldObj.rayTraceBlocks_do_do(vec3d, vec3d1, false, true);
	    	vec3d = worldObj.getWorldVec3Pool().getVecFromPool(userEntity.posX, userEntity.posY, userEntity.posZ);
	    	vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(userEntity.posX + xVector, userEntity.posY + yVector, userEntity.posZ + zVector);
	    	//何らかのブロックに当たっているなら
	        if (movingObjectPosition != null)
	        {
	        	//終点を当たった点に変更
	        	/*vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(movingObjectPosition.hitVec.xCoord, movingObjectPosition.hitVec.yCoord, movingObjectPosition.hitVec.zCoord);
	        	xPos = movingObjectPosition.hitVec.xCoord;
	        	yPos = movingObjectPosition.hitVec.yCoord;
	        	zPos = movingObjectPosition.hitVec.zCoord;*/
	        	count ++;
	        }
			else
			{
				xPos = userEntity.posX + xVector;
				yPos = userEntity.posY + yVector;
				zPos = userEntity.posZ + zVector;
				EntitySukima entitySukima = new EntitySukima(worldObj, userEntity, xPos, yPos, zPos, userEntity.rotationYaw, 17);
				if(!worldObj.isRemote)
				{
					worldObj.spawnEntityInWorld(entitySukima);
				}
				flag = true;
			}
		}

		
		spellCardEnd(140);
	}
	
	//水符「河童のポロロッカ」
	private void spellCard_11()
	{
		if(ticksExisted < 5)return;
		
		if(ticksExisted % 10 == 0)
		{
			thShotLib.createShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, userEntity.rotationYaw + 90F, -60F, 0.3D, 0.3D, 1.0D, 0.0D, -0.03D, 0.0D, 
									3, thShotLib.LIGHT[thShotLib.BLUE], 0.6F, 60, thShotLib.KAPPA01);
			thShotLib.createShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ, userEntity.rotationYaw - 90F, -60F, 0.3D, 0.3D, 1.0D, 0.0D, -0.03D, 0.0D, 
									3, thShotLib.LIGHT[thShotLib.BLUE], 0.6F, 60, thShotLib.KAPPA01);
		}
		spellCardEnd(140);
	}
	
	//魔符「スターダストレヴァリエ」
	private void spellCard_12()
	{
		if(ticksExisted < 5)return;
		
		if(ticksExisted == 5)
		{
			thShotLib.createCircleShotBaseB(userEntity, userEntity, userEntity.posX, userEntity.posY, userEntity.posZ,
					rotationYaw, rotationPitch, 0.5D, 0.5D, 1.0D, 0.0D, 0.0D, 0.0D,
					7, thShotLib.STAR[rand.nextInt(7)], 0.8F, 70, thShotLib.STARDUST01, 7, 0.2D);
		}
		spellCardEnd(60);
	}

    /**
     * (abstract) Protected helper method to write subclass entity data to NBT.
     */
    protected void writeEntityToNBT(NBTTagCompound nbttagcompound)
    {
    	nbttagcompound.setShort("count", (short)count);
    }

    /**
     * (abstract) Protected helper method to read subclass entity data from NBT.
     */
    protected void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
    	count = nbttagcompound.getShort("count");
    }
	
	//スペルカードNoを設定する
	public void setSpellCardNumber(int number)
	{
		dataWatcher.updateObject(18, Integer.valueOf(number));
	}
	
	//スペルカードNoを返す
	public int getSpellCardNumber()
	{
		return dataWatcher.getWatchableObjectInt(18);
	}

    /**
     * Gets how bright this entity is.
     */
    public float getBrightness(float par1)
    {
        return 0.5F;
    }

}
