package net.minecraft.thKaguyaMod;

import net.minecraft.*;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.List;
import java.util.Random;
import net.minecraft.block.Block;
import net.minecraft.block.BlockFlower;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagDouble;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public class EntityTHShot extends Entity
{
	//ショット系のEntityの共通処理

	
	//種類特性変数
	protected String texture;
	protected float shotSize;//弾のサイズ
	
	//個別特性変数
	public EntityLivingBase userEntity;//発射した大元
	public Entity shootingEntity;//発射したEntity
	public double shotSpeed;//弾のスピード
	public double shotMaxSpeed;//弾の最高速度
	public double shotAddSpeed;//弾の加速力
	public boolean hasAccelerations;//加速するか
	public double shotGravityX;//受ける重力値　0.0Dでデフォルト
	public double shotGravityY;
	public double shotGravityZ;
	public double gravityX;
	public double gravityY;
	public double gravityZ;
	boolean isGravity;//重力の影響を受けるかどうか
	protected int shotDamage;//弾によるダメージ
	public int color;//弾の色
	public int deadTime;//消滅時間
	public double xVec;//X軸方向の移動ベクトル
	public double yVec;//Y軸方向の移動ベクトル
	public double zVec;//Z軸方向の移動ベクトル
	public int shotType;//弾独自の動作を表す 0は何もしない
	protected boolean reachShotMaxSpeed;//最高速度に到達したかのフラグ
	protected int lastTime;
	
	public double lastSpeed;
	public float lastRotationYaw;
	public float lastRotationPitch;
	public boolean stopFlag;
	public double lastShotMotionX;
	public double lastShotMotionY;
	public double lastShotMotionZ;
	
	protected int xTile;
    protected int yTile;
    protected int zTile;
    protected int inTile;
    protected boolean inGround;//地面に触れているかのチェック
    protected int ticksAlive;//
    protected int ticksInAir;//空中にいる時間
    public double accelerationX;//X軸方向の加速度
    public double accelerationY;//Y軸方向の加速度
    public double accelerationZ;//Z軸方向の加速度
	
	public static double GRAVITY_DEFAULT = -0.03D;//標準の重力値
	


	
	
	//ワールド読み込み時に呼び出されるコンストラクト
    public EntityTHShot(World world)
    {
        super(world);
        xTile = -1;
        yTile = -1;
        zTile = -1;
        inTile = 0;
        inGround = false;
        ticksInAir = 0;
        setSize(0.5F, 0.5F);
    	gravityX = 0.0D;
    	gravityY = 0.0D;
    	gravityZ = 0.0D;
    	
    }

	/*
	*わからんので、翻訳機使用　描画判定のチェックか？
	*エンティティかどうかをチェックするには、遠くに過去を使用し、その平均エッジと比較することで、レンダリングする範囲内にある
	*長さ* 64 * renderDistanceWeightの引数：距離
	*/
	@SideOnly(Side.CLIENT)
    public boolean isInRangeToRenderDist(double d)
    {
        double d1 = boundingBox.getAverageEdgeLength() * 4D;
        d1 *= 64D;
        return d < d1 * d1;
    	//return true;
    }
	
	public EntityTHShot(World world, EntityLivingBase entityUser, Entity entity,
		double xPos, double yPos, double zPos,
    	double xVector, double yVector, double zVector,
    	double firstSpeed, double maxSpeed, double addSpeed,
    	double xVectorG, double yVectorG, double zVectorG, int damage, int c, float size, int dead, int type)
    {
        super(world);
    	
    	userEntity = entityUser;//弾の持ち主
    	shootingEntity = entity;//弾を発射したもの
    	/*if(xVectorG == 0.0D && yVectorG == 0.0D && zVectorG == 0.0D)
    	{
    		isGravity = false;
    		shotGravityX = xVector;
    		shotGravityY = yVector;
    		shotGravityZ = zVector;
    	}
    	else
    	{
    		isGravity = true;
    		shotGravityX = xVectorG;
    		shotGravityY = yVectorG;
    		shotGravityZ = zVectorG;
    	}*/
    	//重力ベクトルの設定
    	isGravity = false;
    	shotGravityX = xVectorG;
    	shotGravityY = yVectorG;
    	shotGravityZ = zVectorG;
    	
    	//弾の効果が形状を設定
    	shotDamage = damage;//当たったときのダメージ
    	color = c;//弾幕の形状、色
    	setShotColor(color);//弾の色を設定
		deadTime = dead;//消滅時間
    	setDeadTime(deadTime);//弾の消滅時間を設定
    	shotType = type;//特殊動作や特殊効果のタイプ
    	//大きさを設定
    	setShotSize(size);
        setSize(size, size);
    	
    	//速さ関係の設定
		shotSpeed = firstSpeed;//弾の初期速度
    	shotMaxSpeed = maxSpeed;//弾の最大速度、または最低速度
    	shotAddSpeed = addSpeed;//弾の加速度
    	xVec = xVector;
    	yVec = yVector;
    	zVec = zVector;
    	if(hasAccelerations = firstSpeed != maxSpeed)
    	{
        	accelerationX = xVec * maxSpeed * addSpeed;
        	accelerationY = yVec * maxSpeed * addSpeed;
        	accelerationZ = zVec * maxSpeed * addSpeed;
    		reachShotMaxSpeed = false;//弾が最高速度または最低速度に達しているかどうか
    	}
    	else
    	{
    		//accelerationX = xVec * maxSpeed;
        	//accelerationY = yVec * maxSpeed;
        	//accelerationZ = zVec * maxSpeed;
    		accelerationX = 0.0D;
        	accelerationY = 0.0D;
        	accelerationZ = 0.0D;
    		reachShotMaxSpeed = true;//弾が最高速度または最低速度に達しているかどうか
    	}
    	lastSpeed = shotSpeed;
    	
    	//移動量の設定
    	motionX = xVec * firstSpeed;//初期移動量はベクトル*初期速度
    	motionY = yVec * firstSpeed;
    	motionZ = zVec * firstSpeed;
    	lastShotMotionX = motionX;
    	lastShotMotionY = motionY;
    	lastShotMotionZ = motionZ;
    	//角度の設定
    	rotationYaw = (float)Math.atan2(motionX, motionZ) / 3.141593F * 180F;//移動量から水平方向角度を算出
    	rotationPitch = (float)Math.atan2( motionY, Math.sqrt(motionX * motionX + motionZ * motionZ)) / 3.141593F * 180F;//移動量から垂直方向角度を算出
    	rotationPitch %= 90F;
        setRotation(rotationYaw, rotationPitch);
    	lastRotationYaw = rotationYaw;
    	lastRotationPitch = rotationPitch;
    	
    	//発射地点
    	if(entity instanceof EntityLivingBase)//発射主がEntityLivingBaseなら目の高さに合わせる
    	{
    		setPosition(xPos + xVec * 0.2D,
    					yPos + yVec * 0.2D + (double)entityUser.getEyeHeight() - 0.25D, 
    					zPos + zVec * 0.2D);
    	}
    	else
    	{
    		setPosition(xPos + xVec * 0.2D, yPos + yVec * 0.2D, zPos + zVec * 0.2D);
    	}
    	
    	stopFlag = false;
    	lastTime = 0;

    }
	
	//通常弾の基本設定
	public EntityTHShot(World world, EntityLivingBase entityUser, Entity entity,
		double xPos, double yPos, double zPos,
    	double xVector, double yVector, double zVector,
    	double firstSpeed, double maxSpeed, double addSpeed,
    	double xVectorG, double yVectorG, double zVectorG, int damage, int c, float size, int dead)
    {
    	this(world, entityUser, entity, xPos, yPos, zPos, xVector, yVector, zVector, 
    		firstSpeed, maxSpeed, addSpeed, xVectorG, yVectorG, zVectorG, damage, c, size, dead, 0);
    }
	
	public EntityTHShot(World world, EntityLivingBase EntityLivingBase,
    	double xVector, double yVector, double zVector,
    	double firstSpeed, double maxSpeed, double addSpeed,
    	int damage, int color, float size, int dead)
    {
    	this(world, EntityLivingBase, EntityLivingBase, EntityLivingBase.posX, EntityLivingBase.posY, EntityLivingBase.posZ,
    		xVector, yVector, zVector, firstSpeed, maxSpeed, addSpeed, damage, color, size, dead);
    }

	//発射地点が発射元と同じ場合の基本設定
    public EntityTHShot(World world, EntityLivingBase entityUser, Entity entity,
    	double xVector, double yVector, double zVector,
    	double firstSpeed, double maxSpeed, double addSpeed,
    	double xVectorG, double yVectorG, double zVectorG, int damage, int c, float size, int dead)
    {
    	this(world, entityUser, entity, entity.posX, entity.posY, entity.posZ, xVector, yVector, zVector,
    		firstSpeed, maxSpeed, addSpeed, xVectorG, yVectorG, zVectorG, damage, c, size, dead, 0);
    }
	
	//最も一般的なショット　加速なし、機動変化なし
	public EntityTHShot(World world, EntityLivingBase EntityLivingBase, double xVector, double yVector, double zVector,
		double speed, int damage, int c ,float size)
    {
    	this(world, EntityLivingBase, EntityLivingBase, xVector, yVector, zVector,
    		speed, speed, 1.0D, 0.0D, 0.0D, 0.0D, damage, c, size, 120);
    }
	
	//最も一般的なショットに初速度と最高速と加速度があるもの
	public EntityTHShot(World world, EntityLivingBase EntityLivingBase, double xVector, double yVector, double zVector,
		double firstSpeed, double maxSpeed, double addSpeed, int damage, int c, float size)
    {
    	this(world, EntityLivingBase, EntityLivingBase, xVector, yVector, zVector,
    		firstSpeed, maxSpeed, addSpeed, 0.0D, 0.0D, 0.0D, damage, c, size, 120);
    }
	
	//Entity生成時に一度だけ呼ばれる
	protected void entityInit()
	{
		//dataWatcher.addObject(22, new Integer(0));
		//dataWatcher.addObject(23, new Integer(0));
		//dataWatcher.addObject(24, new Integer(0));
		dataWatcher.addObject(18, new Integer(0));
		dataWatcher.addObject(19, new Integer(0));
		dataWatcher.addObject(20, new Integer(0));
		//dataWatcher.addObject(17, new Integer(0));
	}
	
	//移動量から弾の速度を返す
	public double getSpeed()
	{
		return (double)MathHelper.sqrt_double( motionX * motionX + motionY * motionY + motionZ * motionZ);
	}
	
	//最後に時間が動いていた時の弾の速度を返す
	public double getLastSpeed()
	{
		return (double)MathHelper.sqrt_double( lastShotMotionX * lastShotMotionX + lastShotMotionY * lastShotMotionY + lastShotMotionZ * lastShotMotionZ);
	}

	//ベクトルを更新する
	public void setVector()
	{
		//rotationYaw = (float)Math.atan2(lastShotMotionX, lastShotMotionZ) / 3.141593F * 180F;
		//rotationPitch = (float)Math.atan2(lastShotMotionY, Math.sqrt( lastShotMotionX * lastShotMotionX + lastShotMotionZ * lastShotMotionZ)) / 3.141593F * 180F;
		
        //角度に合わせてベクトルを更新
        xVec =  Math.sin( rotationYaw / 180F * (float)Math.PI) * Math.cos( rotationPitch / 180F * (float)Math.PI);//X方向　水平方向
        yVec =  Math.sin( rotationPitch / 180F * (float)Math.PI);//Y方向　上下
        zVec =  Math.cos( rotationYaw / 180F * (float)Math.PI) * Math.cos( rotationPitch / 180F * (float)Math.PI);//Z方向　水平方向
        //加減速するなら、加速度を更新
        if(hasAccelerations)
        {
        	accelerationX = xVec * shotMaxSpeed * shotAddSpeed;
        	accelerationY = yVec * shotMaxSpeed * shotAddSpeed;
        	accelerationZ = zVec * shotMaxSpeed * shotAddSpeed;
        }

		/*else if(getSpeed() < 0.005D)
		{
			accelerationX = xVec * shotMaxSpeed;
        	accelerationY = yVec * shotMaxSpeed;
        	accelerationZ = zVec * shotMaxSpeed;
		}*/
	}
	
	//ショットが存在する限り呼び出されるメソッド
	@Override
    public void onUpdate()
    {	
    	//弾の主がいないか、死んでいる場合消える
    	if (!worldObj.isRemote && userEntity == null)
        {
            setDead();
        	return;
        }
    	else
    	{
    		super.onUpdate();
    	}
    	
    	if(shotDamage <= 0)
    	{
    		if(!worldObj.isRemote)
    		{
    			setDead();
    			return;
    		}
    	}
	
    	if(userEntity != null)
    	{
			if(!worldObj.isRemote && (userEntity.isDead || userEntity.func_110143_aJ()/*getHealth()*/ <= 0.0F))
			{
				if(userEntity instanceof EntityPlayer == false)
				{
					EntityItem entityItem = new EntityItem(worldObj, posX, posY, posZ, new ItemStack(mod_thKaguya.shotMaterialItem, 1));
					worldObj.spawnEntityInWorld(entityItem);
					entityItem.age = 5700;//アイテムがすぐ消滅するよう設定（１5秒で消える）
				}
				setDead();
				return;
			}
    	}
 
    	//消滅時間を過ぎたら消滅
    	if(!worldObj.isRemote && ticksExisted >= getDeadTime())
    	{
    		setDead();
    	}
    	
    	extinguish();//火はつかないようにする
    	
    	//時間が進んでいないなら
    	if(ticksExisted <= lastTime)
    	{
    		return;//処理を終了させる
    	}
    	else//時間が通常通り進んでいるなら
    	{
    		//何事もなかったように移動量を設定する
    		motionX = lastShotMotionX;
    		motionY = lastShotMotionY;
    		motionZ = lastShotMotionZ;
    	}
    	
    	
        /*motionX = xVec * shotSpeed;
        motionY = yVec * shotSpeed;
        motionZ = zVec * shotSpeed;
*/
    	//加速処理と限界速度処理
    	if(reachShotMaxSpeed)//すでに速度が上限、下限に近いなら
    	{
    		//あまりに速度が違うならやり直す
    		if(getSpeed() > shotMaxSpeed + 0.005D || getSpeed() < shotMaxSpeed - 0.005D)
    		{
    			reachShotMaxSpeed = false;
    		}
    	}
    	else if(getSpeed() < shotMaxSpeed)//上限速度より今の速度が遅いなら加速させる
    	{
    		this.motionX += this.accelerationX;
        	this.motionY += this.accelerationY;
        	this.motionZ += this.accelerationZ;
    		reachShotMaxSpeed = true;
    	}
    	else//加減速度より今の速度が速いなら減速させる
    	{
    		this.motionX -= this.accelerationX;
        	this.motionY -= this.accelerationY;
        	this.motionZ -= this.accelerationZ;
    		reachShotMaxSpeed = true;
    	}
    	//弾ごとの特殊な動作を発生させる
    	specialMotion();
    	setGravityLevel();
    	setVector();
    	//最終的な移動量を現在地に加える
        this.posX += this.motionX;
        this.posY += this.motionY;
        this.posZ += this.motionZ;
        
        shotSpeed = getSpeed();
    	
    	
    	//衝突処理
    	hitCheck();
    	
        setPosition(this.posX, this.posY, this.posZ);//位置の更新を行う
    	
    	//通常通り時間が進んでいるなら
    	if(ticksExisted > lastTime)
    	{
    		//最後に時間が動いていたときの時間と移動量を保存する
    		lastTime = ticksExisted;
    		lastShotMotionX = motionX;
    		lastShotMotionY = motionY;
    		lastShotMotionZ = motionZ;
    		lastRotationYaw = (float)Math.atan2(lastShotMotionX, lastShotMotionZ) / 3.141593F * 180F;
    		lastRotationPitch = (float)Math.atan2(lastShotMotionY, Math.sqrt( lastShotMotionX * lastShotMotionX + lastShotMotionZ * lastShotMotionZ)) / 3.141593F * 180F;
    	}
    }
	
	//衝突処理
	public void hitCheck()
	{
	    //始点（現在地）
    	Vec3 vec3d = worldObj.getWorldVec3Pool().getVecFromPool(posX, posY, posZ);
    	//終点（現在地に移動量を足した点）
    	Vec3 vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(posX + motionX, posY + motionY, posZ + motionZ);
        //始点と終点からブロックとの当たりを取得
    	MovingObjectPosition movingObjectPosition = worldObj.rayTraceBlocks_do_do(vec3d, vec3d1, false, true);
    	vec3d = worldObj.getWorldVec3Pool().getVecFromPool(posX, posY, posZ);
    	vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(posX + motionX, posY + motionY, posZ + motionZ);
    	//何らかのブロックに当たっているなら
        if (movingObjectPosition != null)
        {
        	//終点を当たった点に変更
        	vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(movingObjectPosition.hitVec.xCoord, movingObjectPosition.hitVec.yCoord, movingObjectPosition.hitVec.zCoord);
        }
    	
    	
        Entity entity = null;//実際に当たったことにするEntity
    	double d = 0.0D;//そのEntityまでの仮の距離
		float hitSize = getShotSize() * 0.5F;
    	//ここから移動量分の線分を作り、それに弾の大きさの２倍の肉付けをし直方体を作る。それに当たったEntityをリスト化する\\
        List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.addCoord(motionX, motionY, motionZ).expand(hitSize, hitSize, hitSize));//指定範囲内のEntityをリストに登録
		
    	for (int j = 0; j < list.size(); j++)
        {
            Entity entity1 = (Entity)list.get(j);//entity1にリストの先端のentityを保存
        	//entity1が、当たり判定を取らない　または　entity1が使用者　または　飛んで25カウント以下？　または　EntityTHShotならパス
            if ( entity1.canBeCollidedWith() && 
            	!entity1.isEntityEqual(userEntity) && 
            	!entity1.isEntityEqual(shootingEntity) &&
            	!hitCheckEx(entity1) && 
            	entity1 instanceof EntityPrivateSquare == false &&
            	entity1 instanceof EntityAnimal == false &&
            	entity1 instanceof EntityLivingBase &&
            	!(userEntity instanceof EntityTHFairy && entity1 instanceof EntityTHFairy))
        	{
        		//判定を弾の大きさに変更
            	AxisAlignedBB axisalignedbb = entity1.boundingBox.expand(hitSize, hitSize, hitSize);
            	MovingObjectPosition movingObjectPosition1 = axisalignedbb.calculateIntercept(vec3d, vec3d1);
        		//この判定で当たっているなら
            	if (movingObjectPosition1 != null)
            	{
        			//当たっているならここからその点までの距離を取得
            		double d1 = vec3d.distanceTo(movingObjectPosition1.hitVec);
        			//今までの一番近くにいるなら、一番近いEntityを更新する
            		if (d1 < d || d == 0.0D)
            		{
                		entity = entity1;
                		d = d1;
            		}
        		}
        	}
        }

    	//当たったEntityがいるなら、当たったEntityをMovingObjectPositionで登録
        if (entity != null)
        {
            movingObjectPosition = new MovingObjectPosition(entity);
        }
		
		if (movingObjectPosition != null && movingObjectPosition.entityHit != null && movingObjectPosition.entityHit instanceof EntityPlayer)
        {
        	EntityPlayer entityPlayer = (EntityPlayer)movingObjectPosition.entityHit;

            if (entityPlayer.capabilities.disableDamage || shootingEntity instanceof EntityPlayer && !((EntityPlayer)shootingEntity).func_96122_a(entityPlayer))
            {
            	movingObjectPosition = null;
            }
        }
		
    	//MovingObjectPositionで当たっているなら
        if (movingObjectPosition != null)
        {
        	//当たった場合の処理をする
            onImpact(movingObjectPosition);
        }
	}
	
	//独自の動きを追加するためのもの
	public void specialMotion()
	{
		switch(shotType)
		{
			case thShotLib.KAPPA01:
				if(ticksExisted % 4 == 3)
				{
					thShotLib.createShotBaseB(userEntity, userEntity, posX, posY, posZ, userEntity.rotationYaw + rand.nextFloat() * 30F - 15F, -30F, 0.03D, 0.3D, 0.08D, 0.0D, -0.03D, 0.0D,
											3, thShotLib.LIGHT[thShotLib.BLUE], 0.3F, 100, thShotLib.BOUND01);
				}
				break;
			case thShotLib.FREEZE01:
				if(ticksExisted == 20)
				{
					shotMaxSpeed = 0.4;
					shotAddSpeed = 0.02;
					hasAccelerations = true;
				}
				break;
			case thShotLib.FLOWER01:
				if(rotationPitch > -90F)
				{
					rotationPitch -= 3;
				}
				break;
			case thShotLib.KISHITU01://気質弾
				if(ticksExisted < 20)
				{
					setShotSize(getShotSize() + 0.1F);
				}
				break;
			case thShotLib.STARDUST01:
				rotationYaw += 2F;
				//rotationPitch += 10F;
				//setVector();
				//thShotLib.createShotBaseB(userEntity, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180 - 90F, 0.3D, 0.03D, -0.7D, 0.0D, 0.0D, 0.0D, 5, thShotLib.STAR[rand.nextInt(7)], 0.3F, 50, 0);
				thShotLib.createShotBaseA(userEntity, this, posX, posY, posZ, -xVec, -yVec, -zVec, 0.3D, 0.03D, -0.7D, 0.0D, 0.0D, 0.0D, 5, thShotLib.STAR[rand.nextInt(7)], 0.3F, 50, 0);
				break;
			case thShotLib.KOKUSHI01://二重黒死蝶の蝶弾
				if(ticksExisted < 25)
				{
					motionX *= 0.90D;
					motionY *= 0.90D;
					motionZ *= 0.90D;
				}
				else if(ticksExisted < 80)
				{
					if(color % 2 == 0)
					{
						rotationYaw += 10F;
					}
					else
					{
						rotationYaw -= 10F;
					}
					rotationPitch -= MathHelper.sin(rotationPitch / 180F * 3.141593F) * 90F;
					if(getSpeed() < 1.3D)
					{
						motionX += xVec * (ticksExisted - 25) * 0.003D;
						motionY += yVec * (ticksExisted - 25) * 0.003D;
						motionZ += zVec * (ticksExisted - 25) * 0.003D;
					}
			
				}

				break;
			default:
				break;
		}
	}

	//ブロックやEntityに当たった時の処理
    protected void onImpact(MovingObjectPosition movingObjectPosition)
    {
    	//当たった時の処理
    	if (!worldObj.isRemote)
    	{
    		Entity hitEntity = movingObjectPosition.entityHit;
        
    		//当たったEntityがいるなら
    		if ( hitEntity != null )
        	{
        		//それがEntityTHShotに属していないなら
        		if(hitEntity instanceof EntityTHShot == false)
        		{
        			//Entityに当たった時の特殊な処理
        			entityHitSpecialProcess(hitEntity);
        			//指定したダメージ分の魔法ダメージを与える
					if (!hitEntity.attackEntityFrom(DamageSource.causeIndirectMagicDamage(this, userEntity), shotDamage));
        			//弾を消滅させる
        			setDead();
        		}
        		//EntityTHShotに属しているなら
        		else
        		{
        			EntityTHShot entityTHShot = (EntityTHShot)hitEntity;
        			/*if(getShotStrength() == entityTHShot.getShotStrength())
        			{
        				//setDead();
        				//entityTHShot.setDead();
        			}
        			//相手の方が強いなら
        			else if(getShotStrength() < entityTHShot.getShotStrength())
        			{
        				//この弾を消滅させる
        				this.setDead();
        			}
        			//自分の方が強いなら
        			else
        			{
        				//相手の弾を消滅させる
        				entityTHShot.setDead();
        			}*/
        			if(userEntity != entityTHShot.userEntity)//使用者の違う弾同士は打ち消し合う
        			{
        				//弾同士の相殺
        				//お互い弾のダメージ分だけ小さくする
        				int shotDamageA = this.shotDamage;
        				this.shotDamage -= entityTHShot.shotDamage;
        				entityTHShot.shotDamage -= shotDamageA;
        				//setDead();
        				//entityTHShot.setDead();
        			}
        		}
			}
    		else
    		{
    			if(blockHitSpecialProcess(movingObjectPosition))
    			{
        			this.setDead();//ブロックに当たったら消滅
    			}
    		}
    	}
    }
	
	public void entityHitSpecialProcess(Entity hitEntity)
	{
		switch(this.shotType)
		{
			case thShotLib.WIND01:
				hitEntity.motionX += motionX * 3.0D;
				hitEntity.motionY += motionY * 3.0D;
				hitEntity.motionZ += motionZ * 3.0D;
				if(!hitEntity.onGround)
				{
					shotDamage *= 2;
				}
				break;
			case thShotLib.AJA01:
				//指定したダメージ分の魔法ダメージを与える
        		if(hitEntity instanceof EntityLivingBase)
        		{
        			EntityLivingBase EntityLivingBase = (EntityLivingBase)hitEntity;
        			if(EntityLivingBase.getCreatureAttribute() == EnumCreatureAttribute.UNDEAD)//アンデッドなら
        			{
        				//通常の2倍のダメージを与える
        				EntityLivingBase.attackEntityFrom(DamageSource.causeIndirectMagicDamage(this, userEntity), shotDamage * 2);
        				EntityLivingBase.setFire(shotDamage);
        				worldObj.playSoundEffect(posX, posY, posZ, "random.fizz", 0.5F, 2.6F + (worldObj.rand.nextFloat() - worldObj.rand.nextFloat()) * 0.8F);
        				for (int l = 0; l < 8; l++)
                    	{
                       		worldObj.spawnParticle("largesmoke", posX + Math.random(), posY + Math.random(), posZ + Math.random(), 0.0D, 0.0D, 0.0D);
                    	}
        			}
        			else
        			{
        				EntityLivingBase.attackEntityFrom(DamageSource.causeIndirectMagicDamage(this, userEntity), shotDamage);
        			}
        		}
				break;
			default:
				break;
		}
	}
	
	//ブロックとの衝突時の特別な処理 shotTypeで処理は決めている
	public boolean blockHitSpecialProcess(MovingObjectPosition movingObjectPosition)
	{
		switch(this.shotType)
		{
			case thShotLib.BOUND01:
				bound(movingObjectPosition, 0.9D);
				return false;
			case thShotLib.KAPPA01:
				bound(movingObjectPosition, 0.9D);
				return false;
			case thShotLib.KISHITU01:
				kishitudan();
				return true;
			case thShotLib.FLOWER01:
				flowerWorld();
				return true;
			default:
				return true;
			
		}
	}
	
	//跳ね返り弾
	private void bound(MovingObjectPosition movingObjectPosition, double returnRate)
	{
		
		double supPosX1 = posX;
        double supPosX2 = posX + motionX;//movingObjectPosition.hitVec.xCoord;
        double supPosY1 = posY;
        double supPosY2 = posY + motionY;//movingObjectPosition.hitVec.yCoord;
        double supPosZ1 = posZ;
        double supPosZ2 = posZ + motionZ;//movingObjectPosition.hitVec.zCoord;
		
		//始点を登録
        Vec3 supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    	//終点を登録
    	Vec3 supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
        //始点と終点からブロックとの衝突を取得
    	movingObjectPosition = worldObj.rayTraceBlocks_do_do(supVec3d1, supVec3d2, false, true);
        //始点を登録
        supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    	//終点を登録
    	supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
		
		int returnCount = 0;//跳ね返り過ぎて無限ループに陥ったときの対処
		
		while(movingObjectPosition != null)
        {
	        switch(movingObjectPosition.sideHit)
	        {
	            case 0:
	            	motionY *= -returnRate;
	            	accelerationY *= -returnRate;
	            	break;
	            case 1:
	            	motionY *= -returnRate;
	            	accelerationY *= -returnRate;
	            	break;
	            case 2:
	            	motionZ *= -returnRate;
	            	accelerationZ *= -returnRate;
	            	break;
	            case 3:
	            	motionZ *= -returnRate;
	            	accelerationZ *= -returnRate;
	            	break;
	            case 4:
	            	motionX *= -returnRate;
	            	accelerationX *= -returnRate;
	            	break;
	            default:
	            	motionX *= -returnRate;
	            	accelerationX *= -returnRate;
	            	break;
	        }
            supPosX1 = supPosX1 + (movingObjectPosition.hitVec.xCoord - supPosX1) * 0.999D;
            supPosX2 = supPosX1 + motionX;
            supPosY1 = supPosY1 + (movingObjectPosition.hitVec.yCoord - supPosY1) * 0.999D;
            //supPosY1 = supMovingObjectPosition.hitVec.yCoord;
            supPosY2 = supPosY1 + motionY;
            supPosZ1 = supPosZ1 + (movingObjectPosition.hitVec.zCoord - supPosZ1) * 0.999D;
            supPosZ2 = supPosZ1 + motionZ;
        	//始点を登録
            supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    		//終点を登録
    		supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
        	//始点と終点からブロックとの衝突を取得
    		movingObjectPosition = worldObj.rayTraceBlocks_do_do(supVec3d1, supVec3d2, false, true);
            //始点を登録
            supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    		//終点を登録
    		supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
        	
        	returnCount++;
        	if(returnCount > 4)
        	{
        		setDead();
        		return;
        	}
        }
	}
	
	//気質弾
	private void kishitudan()
	{
		//for(int i = 0; i < 2; i++)
    	{
	    	EntityTHShot entityTHShot;
	    	double xVector, yVector, zVector;
	    	float angleXZ, angleY;
	    	angleXZ = rand.nextFloat() * (float)Math.PI * 2F;
	    	angleY  = rand.nextFloat() * (float)Math.PI * 2F;
	    	xVector = -Math.sin(angleXZ) * Math.cos(angleY);
	    	yVector = -Math.sin(angleY);
	    	zVector =  Math.cos(angleXZ) * Math.cos(angleY);
	    	entityTHShot = new EntityTHShot( worldObj, userEntity, this, posX, posY, posZ,
	    		xVector, yVector, zVector, 0.01D, 0.15D, 0.01D, 0.0D, 0.0D, 0.0D,
	    		4, 40, 0.3F, 90);
	    	worldObj.spawnEntityInWorld(entityTHShot);
    	}
	}
	
	//着弾地点に花を咲かす
	private void flowerWorld()
	{
		Random random = new Random();
    	int hitPointX = (int)posX;
    	int hitPointY = (int)(posY - 0.3D);
    	int hitPointZ = (int)posZ;
    	int hitPointBlock = worldObj.getBlockId(hitPointX, hitPointY, hitPointZ);
    	if(hitPointBlock == Block.grass.blockID)
    	{
    		int setX = hitPointX;
    		int setY = hitPointY + 1;
    		int setZ = hitPointZ;
    		if(worldObj.isAirBlock(setX, setY, setZ))
    		{
    			if(getShotColor() % 8 == 3)//黄色の弾幕なら
    			{
    				if(!worldObj.isRemote)
    				{
    					//黄色い花を咲かす
    					worldObj.setBlock(setX, setY, setZ, BlockFlower.plantYellow.blockID, 1, 3);
    				}
    			}
    			else if(getShotColor() % 8 == 0)//赤色の弾幕なら
    			{
    				if(!worldObj.isRemote)
    				{
    					//赤い花を咲かす
    					worldObj.setBlock(setX, setY, setZ, BlockFlower.plantRed.blockID, 1, 3);
    				}
    			}
    		}
    	}
	}

    //データを保存する
	@Override
    public void writeEntityToNBT(NBTTagCompound nbtTagCompound)
    {
        /*nbtTagCompound.setShort("xTile", (short)this.xTile);
        nbtTagCompound.setShort("yTile", (short)this.yTile);
        nbtTagCompound.setShort("zTile", (short)this.zTile);
        nbtTagCompound.setByte("inTile", (byte)this.inTile);
        nbtTagCompound.setByte("inGround", (byte)(this.inGround ? 1 : 0));*/
        nbtTagCompound.setTag("direction", this.newDoubleNBTList(new double[] {this.motionX, this.motionY, this.motionZ}));
    }

    //データを読み込む
	@Override
    public void readEntityFromNBT(NBTTagCompound nbtTagCompound)
    {
        /*this.xTile = nbtTagCompound.getShort("xTile");
        this.yTile = nbtTagCompound.getShort("yTile");
        this.zTile = nbtTagCompound.getShort("zTile");
        this.inTile = nbtTagCompound.getByte("inTile") & 255;
        this.inGround = nbtTagCompound.getByte("inGround") == 1;*/

        if (nbtTagCompound.hasKey("direction"))
        {
            NBTTagList var2 = nbtTagCompound.getTagList("direction");
            this.motionX = ((NBTTagDouble)var2.tagAt(0)).data;
            this.motionY = ((NBTTagDouble)var2.tagAt(1)).data;
            this.motionZ = ((NBTTagDouble)var2.tagAt(2)).data;
        }
        else
        {
            this.setDead();
        }
    }
	
	//当たり判定の追加
	public boolean hitCheckEx(Entity entity)
	{
		return false;
	}
    	
    //弾の強さ
    public int getShotStrength()
    {
    	return 10;
    }
	
	//重力値を設定　0.0Dで通常の重力になる
	public void setGravityLevel()
	{
		/*gravityX += shotGravityX;
		gravityY += shotGravityY;
		gravityZ += shotGravityZ;
		motionX += gravityX;
		motionY += gravityY;
		motionZ += gravityZ;*/
		motionX += shotGravityX;
		motionY += shotGravityY;
		motionZ += shotGravityZ;
		//motionY -= g;
	}
	
	//重力の影響を受けるかどうか返す
	public boolean hasGravityLevel()
	{
		if(shotGravityX == 0.0D && shotGravityY == 0.0D && shotGravityZ == 0.0D)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

    public boolean canBeCollidedWith()
    {
        return true;
    }

    public float getCollisionBorderSize()
    {
        return 1.0F;
    }
    	
    //跳ね返せる弾かどうか
    protected boolean isReturnableShot()
    {
    	return false;
    }

    //Entityからの攻撃を受けたときの処理　要は跳ね返す処理
    public boolean attackEntityFrom(DamageSource damageSource, int i)
    {
        setBeenAttacked();
        if (isReturnableShot() && damageSource.getEntity() != null)
        {
            Vec3 vec3d = damageSource.getEntity().getLookVec();
            if (vec3d != null)
            {
                motionX = vec3d.xCoord;
                motionY = vec3d.yCoord;
                motionZ = vec3d.zCoord;
            	xVec = vec3d.xCoord;
            	yVec = vec3d.yCoord;
            	zVec = vec3d.zCoord;
                accelerationX = motionX * 0.10000000000000001D;
                accelerationY = motionY * 0.10000000000000001D;
                accelerationZ = motionZ * 0.10000000000000001D;
            }
            if (damageSource.getEntity() instanceof EntityLivingBase)
            {
                shootingEntity = (EntityLivingBase)damageSource.getEntity();
            }
            return true;
        }
        else
        {
            return false;
        }
    }
	
	//消滅時間を設定
	public void setDeadTime(int time)
	{
		dataWatcher.updateObject(18, Integer.valueOf(time));
	}
	//消滅時間を返す
	public int getDeadTime()
	{
		return dataWatcher.getWatchableObjectInt(18);
	}
	
	//ショットの色を設定
	public void setShotColor(int par1)
	{
		dataWatcher.updateObject(19, Integer.valueOf(par1));
	}
	//ショットの色を返す
	public int getShotColor()
	{
		return dataWatcher.getWatchableObjectInt(19);
	}
	
	//ショットの大きさを設定（レーザーの場合は太さ）
	public void setShotSize(float size)
	{
		dataWatcher.updateObject(20, Integer.valueOf((int)(size * 100F)));
	}
	
	//ショットの大きさを返す（レーザーの場合は太さ）
	public float getShotSize()
	{
		return (float)dataWatcher.getWatchableObjectInt(20) / 100F;
	}

	@SideOnly(Side.CLIENT)
    public float getShadowSize()
    {
        return 0.0F;
    }

    public float getBrightness(float f)
    {
        return 1.0F;
    }

	@SideOnly(Side.CLIENT)
    public int getBrightnessForRender(float f)
    {
        return 0xf000f0;
    }
	
}
