package net.minecraft.thKaguyaMod;

import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.player.ArrowLooseEvent;
import net.minecraftforge.event.entity.player.ArrowNockEvent;
import net.minecraft.item.*;
import net.minecraft.world.World;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.MathHelper;

import java.util.List;
import java.util.Random;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class ItemAjaRedStone extends Item
{
	
	//エイジャの赤石
	//光を貯めてアンデッド特効のレーザーを発射する
	
	public ItemAjaRedStone(int itemID)
	{
		super(itemID);
		func_111206_d("ajaRedStone");//テクスチャの指定
		setMaxDamage(300);//耐久値だが、ここではチャージの具合を表すものとして使用している。
		this.maxStackSize = 1;
		this.setCreativeTab(CreativeTabs.tabCombat);
	}

	//右クリックを押したときに呼び出されるメソッド
	@Override
	public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer entityPlayer)
    {
    	entityPlayer.setItemInUse(itemStack, getMaxItemUseDuration(itemStack));//アイテムの使用継続時間を記憶させる
    	
    	EntityAjaRedStoneEffect entityAjaRedStoneEffect = new EntityAjaRedStoneEffect( world, entityPlayer);
    	if(!world.isRemote)
    	{
    		world.spawnEntityInWorld(entityAjaRedStoneEffect);
    	}
    	return itemStack;
    }
	
	//右クリックを終了したときに呼び出されるメソッド
	@Override
	public void onPlayerStoppedUsing(ItemStack itemstack, World world, EntityPlayer entityPlayer, int usedTime)
    {

   	}
	
    public ItemStack onEaten(ItemStack par1ItemStack, World par2World, EntityPlayer par3EntityPlayer)
    {
        return par1ItemStack;
    }
    
    public int getMaxItemUseDuration(ItemStack par1ItemStack)
    {
        return 72000;
    }
	
	//アイテムを使ったときのアクションを指定
	@Override
	public EnumAction getItemUseAction(ItemStack par1ItemStack)
    {
        return EnumAction.block;//右クリック時は剣のガードアクション
    }
	
	//アイテムを発光させるか
	@Override
    @SideOnly(Side.CLIENT)
	public boolean hasEffect(ItemStack itemstack)
	{   
		return true;
    }
	
	//エンチャント可能か
    @Override
	public int getItemEnchantability()
    {
        return 0;//エンチャント適正0
    }
	
	//Forgeの追加メソッド　エンチャントブックの使用を許可するか
	@Override
	public boolean isBookEnchantable(ItemStack itemstack1, ItemStack itemstack2)
    {
        return false;//許可しない
    }
	
	//弓や剣のように大きな描画をするか
	@Override
    public boolean isFull3D()
    {
        return false;//しない
    }
}