package net.minecraft.thKaguyaMod;

import java.util.List;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.EnumToolMaterial;
import net.minecraft.item.Item;
import net.minecraft.item.ItemSword;
import net.minecraft.item.EnumAction;
import net.minecraft.item.ItemStack;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class ItemFrandreRod extends ItemSword
{
	//フランドールの持つ棒
	
	public ItemFrandreRod(int itemID, EnumToolMaterial enumToolMaterial)
	{
		super(itemID, enumToolMaterial);
		setMaxDamage(4);
	}
	
	//右クリックを押したときに呼び出されるメソッド
	@Override
	public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer entityPlayer)
	{
    	entityPlayer.setItemInUse(itemStack, getMaxItemUseDuration(itemStack));//アイテムの使用継続時間を記憶させる？
    	
    	Entity targetEntity = null;
    	double hitX = entityPlayer.posX;
    	double hitY = entityPlayer.posY;
    	double hitZ = entityPlayer.posZ;

    	double xVecMax = -Math.sin(entityPlayer.rotationYaw   / 180F * (float)Math.PI) * Math.cos(entityPlayer.rotationPitch / 180F * (float)Math.PI) * 128.0D;
    	double yVecMax = -Math.sin(entityPlayer.rotationPitch / 180F * (float)Math.PI) * 128.0D;
    	double zVecMax =  Math.cos(entityPlayer.rotationYaw   / 180F * (float)Math.PI) * Math.cos(entityPlayer.rotationPitch / 180F * (float)Math.PI) * 128.0D;
    	//始点（現在地）
    	Vec3 vec3d = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX, entityPlayer.posY + entityPlayer.getEyeHeight(), entityPlayer.posZ);
    	//Vec3 vec3d = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX, entityPlayer.posY, entityPlayer.posZ);
    	//終点（現在地に移動量を足した点）
    	Vec3 vec3d1 = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX + xVecMax, entityPlayer.posY + yVecMax, entityPlayer.posZ + zVecMax);
    	//Vec3 vec3d1 = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX + xVecMax, entityPlayer.posY + yVecMax, entityPlayer.posZ + zVecMax);
        //始点と終点からブロックとの当たりを取得
    	MovingObjectPosition movingObjectPosition = world.rayTraceBlocks_do_do(vec3d, vec3d1, false, true);
    	vec3d = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX, entityPlayer.posY + entityPlayer.getEyeHeight(), entityPlayer.posZ);
    	vec3d1 = world.getWorldVec3Pool().getVecFromPool(entityPlayer.posX + xVecMax, entityPlayer.posY + yVecMax, entityPlayer.posZ + zVecMax);
    	
    	//何らかのブロックに当たっているなら
        if (movingObjectPosition != null)
        {
        	//終点を当たった点に変更
        	vec3d1 = world.getWorldVec3Pool().getVecFromPool(movingObjectPosition.hitVec.xCoord, movingObjectPosition.hitVec.yCoord, movingObjectPosition.hitVec.zCoord);
        	hitX = movingObjectPosition.hitVec.xCoord;
        	hitY = movingObjectPosition.hitVec.yCoord;
        	hitZ = movingObjectPosition.hitVec.zCoord;
        	//double xz_sq = (hitX - setX) * (hitX - setX) + (hitZ - setZ) * (hitZ - setZ);//平面方向の平方

    		Entity entity = null;

    		//このEntityから移動後までの線分に、指定分の範囲を追加した直方体と衝突するEntityのリストを取得
        	List list = world.getEntitiesWithinAABBExcludingEntity(entityPlayer, entityPlayer.boundingBox.addCoord(xVecMax, yVecMax, zVecMax).expand(1.0D, 1.0D, 1.0D));
        	double d = 0.0D;
        	for (int j = 0; j < list.size(); j++)
        	{
		        // 衝突リストから、i番目のEntityを取得
		        Entity entity1 = (Entity)list.get(j);

		    	if(/*entity1.canBeCollidedWith() ||*/ entity1 instanceof EntityLiving)
		    	{
		        	float f2 = 0.3F;
		            AxisAlignedBB axisalignedbb = entity1.boundingBox.expand(f2, f2, f2);
		            MovingObjectPosition movingObjectPosition1 = axisalignedbb.calculateIntercept(vec3d, vec3d1);
		        	//Entityとの衝突がないなら、このEntityはパスする
		            if (movingObjectPosition1 != null)
		            {
		        		//始点からEntityに衝突した点までの距離を取得
		            	double d1 = vec3d.distanceTo(movingObjectPosition1.hitVec);
		        		//今までで一番近いEntity、かつ、５m以上離れているなら、Entityと距離を記憶する
		            	if((d1 < d || d == 0.0D) && d1 > 5.0D)
		            	{		
		                	entity = entity1;
		                	d = d1;
		            	}
		            }
		        }
        	}

		    //Entityに当たっていたなら
		    if (entity != null)
		    {
		        movingObjectPosition = new MovingObjectPosition(entity);
		        movingObjectPosition.entityHit = entity;
		    }
		    	
		    if (movingObjectPosition != null && movingObjectPosition.entityHit != null)
		    {
		    	targetEntity = movingObjectPosition.entityHit;
		       	/*if(movingObjectPosition.entityHit instanceof EntityLiving)
		       	{
		       		EntityLiving hitEntityLiving = (EntityLiving)movingObjectPosition.entityHit;
		       		hitX = hitEntityLiving.posX;
		       		hitY = hitEntityLiving.posY + hitEntityLiving.yOffset / 2.0D;
		       		hitZ = hitEntityLiving.posZ;
		        }
		        else
		        {
		        	hitX = movingObjectPosition.entityHit.posX;
		        	hitY = movingObjectPosition.entityHit.posY + 0.75D;
		        	hitZ = movingObjectPosition.entityHit.posZ;
		        }*/
		    }
		    else
		    {
		    	return itemStack;
		    }
        }
    	
    	if(targetEntity == null)
    	{
    		return itemStack;
    	}
    	
    	EntityObjectEye entityObjectEye = new EntityObjectEye(world, entityPlayer, targetEntity);
    	if(!world.isRemote)
    	{
    		world.spawnEntityInWorld(entityObjectEye);
    	}
    	return itemStack;
    }
	
		//右クリックを終了したときに呼び出されるメソッド
	@Override
	//@SideOnly(Side.CLIENT)
	public void onPlayerStoppedUsing(ItemStack itemstack, World world, EntityPlayer entityPlayer, int usedTime)
    {

   	}
	
	//右クリックを終了したときに呼び出されるメソッド
	//@SideOnly(Side.CLIENT)
	/*@Override
	public void onPlayerStoppedUsing(ItemStack itemstack, World world, EntityPlayer entityPlayer, int usedTime)
    {
    	int time = this.getMaxItemUseDuration(itemstack) - usedTime;
        
        ArrowLooseEvent event = new ArrowLooseEvent(entityPlayer, itemstack, time);
        MinecraftForge.EVENT_BUS.post(event);
        if (event.isCanceled())
        {
            return;
        }
        time = event.charge;

    	if(time > 114)
    	{
    		time = 114;
    	}
    	time /= 3;
    	time *= 20;
    	if(time < 20)
    	{
    		time = 20;
    	}
    	//レッドストーンを消費する
    	if (entityPlayer.inventory.hasItem(Item.redstone.shiftedIndex))
        {
        	//	PotionEffect(ポーションのタイプ,持続時間（秒）*20（20は定数？）,レベル（0がレベル１、1がレベル２）)
        	if(!world.isRemote)
        	{
        		entityPlayer.addPotionEffect(new PotionEffect( 1, time, 1));//スピードアップ
        		entityPlayer.addPotionEffect(new PotionEffect( 5, time, 1));//攻撃力アップ
        		entityPlayer.addPotionEffect(new PotionEffect( 8, time, 1));//跳躍力アップ
        		entityPlayer.addPotionEffect(new PotionEffect(11, time, 1));//防御力アップ
        		//entityPlayer.addPotionEffect(new PotionEffect(12, 15 * 20, 1));//炎耐性
        		world.playSoundAtEntity(entityPlayer, "random.spellcard", mod_thKaguya.SpellCardVol, 1.0F);
        		
        	}
        	entityPlayer.inventory.consumeInventoryItem(Item.redstone.shiftedIndex);//レッドストーン消費
        }
    }*/
	
	//アイテムを発光させる。 trueなら発光
	@Override
	@SideOnly(Side.CLIENT)
	public boolean hasEffect(ItemStack itemstack)
    {   
		return true;
    }
}
