package net.minecraft.thKaguyaMod;

import java.util.List;
import net.minecraftforge.common.MinecraftForge;
import net.minecraft.item.*;
import net.minecraft.world.World;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.util.MathHelper;
import net.minecraft.util.Icon;
import java.util.Random;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class ItemTHLaser extends Item
{
	//単発レーザー
	
	//登録した英語名のアイテム名（？）
	public static final String laserNames[] =
    {
        "Laser", "Short Laser", "Long Laser"
    };
	//アイコンの名前。smallShot.pngを反映させるなら、"smallShot"で対応する。
	public static final String laserIconName[] =
	{
		"Laser1", "Laser2", "Laser3"
	};

	//各弾の弾速。
	public static final float speed[] =
	{
		0.6F, 0.6F, 0.5F, 0.3F, 0.6F, 0.6F, 0.6F, 0.65F, 0.3F, 0.5F,
	};

	//各弾IDの形状
	public static final int form[] =
	{
		thShotLib.SMALL[0]    , thShotLib.TINY[0]     , thShotLib.MEDIUM[0], thShotLib.BIG[0]  , 
		thShotLib.STAR[0]     , thShotLib.SMALLSTAR[0], thShotLib.CIRCLE[0], thShotLib.SCALE[0],
		thShotLib.BUTTERFLY[0], thShotLib.LIGHT[0]
	};
	
	@SideOnly(Side.CLIENT)
    private Icon[] icon;

	public ItemTHLaser(int itemID)
	{
		super(itemID);
		setHasSubtypes(true);
		setMaxDamage(0);
		setCreativeTab(CreativeTabs.tabMaterials);//クリエイティブの素材タブに登録
	}
	
	public String getUnlocalizedName(ItemStack itemStack)
    {
        int i = MathHelper.clamp_int(itemStack.getItemDamage(), 0, 15);
        return super.getUnlocalizedName() + "." + laserNames[i];
    }
	
	@SideOnly(Side.CLIENT)
	//ダメージ値によってアイテムアイコンを変える
    public Icon getIconFromDamage(int damage)
    {
        int i = MathHelper.clamp_int(damage, 0, laserNames.length);
        return this.icon[i];
    }
	
	@SideOnly(Side.CLIENT)
    public void registerIcons(IconRegister par1IconRegister)
    {
        this.icon = new Icon[laserIconName.length];

        for (int i = 0; i < laserIconName.length; ++i)
        {
            this.icon[i] = par1IconRegister.registerIcon(laserIconName[i]);
        }
    }
	
	//右クリックを押したときの処理
	public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer entityPlayer)
	{
		int type = itemStack.getItemDamage();
		int type2 = form[type] / 8;//IDの互換用
		int color = /*form[type] + */itemRand.nextInt(7);
		int sellectbleColor[] = {7, 0, 2, 0, 1, 4, 5, 7, 7, 4, 2, 3, 5, 4, 6, 7};//１６色の染料を８色に対応させるための配列
		ItemStack colorItem = entityPlayer.inventory.mainInventory[entityPlayer.inventory.currentItem + 1];//右横に持っている相手っ無を取得
		if(entityPlayer.inventory.currentItem < 8 && colorItem != null)//右横にアイテムがあるなら
    	{
    		if(colorItem.itemID == Item.dyePowder.itemID)//そのアイテムが染料なら
    		{
    			//染料のダメージ値を取得
    			color = /*form[type] +*/ sellectbleColor[entityPlayer.inventory.mainInventory[entityPlayer.inventory.currentItem + 1].getItemDamage()];
    		}
    	}
		double length = 5.0D;
		if(type == 1)
		{
			length = 2.0D;
		}
		else if(type == 2)
		{
			length = 8.0D;
		}

		thShotLib.createLaserABaseB(entityPlayer, entityPlayer, entityPlayer.posX, entityPlayer.posY, entityPlayer.posZ, entityPlayer.rotationYaw, entityPlayer.rotationPitch,
									0.1D, 0.4D, 0.05D, 0.0D, 0.0D, 0.0D, 6, color, 0.1F, 60, 0, length);
		if(!world.isRemote)
		{
			itemStack.stackSize --;
		}
		
		return itemStack;
	}

	
	@SideOnly(Side.CLIENT)
	//クリエイトモードのアイテム欄に、ダメージ値の違うアイテムも表示できるようにする
    public void getSubItems(int par1, CreativeTabs par2CreativeTabs, List par3List)
    {
        for (int i = 0; i < laserNames.length; i++)
        {
            par3List.add(new ItemStack(par1, 1, i));
        }
    }
	
}