package net.minecraft.thKaguyaMod;

import java.util.List;
import net.minecraftforge.common.MinecraftForge;
import net.minecraft.item.*;
import net.minecraft.world.World;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.util.MathHelper;
import net.minecraft.util.Icon;
import java.util.Random;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class ItemTHShot extends Item
{
	//単発ショット　弾幕作成の素でもある
	
	//登録した英語名のアイテム名（？）
	public static final String shotNames[] =
    {
        "Small Shot", "Tiny Shot", "Medium Shot", "Big Shot", "Star Shot", "Small Star Shot", "Circle Shot", "Scale Shot", "Butterfly Shot", "Light Shot", "Knife Shot"
    };
	//アイコンの名前。smallShot.pngを反映させるなら、"smallShot"で対応する。
	public static final String shotIconName[] =
	{
		"smallShot", "tinyShot", "mediumShot", "bigShot", "starShot", "smallStarShot", "circleShot", "scaleShot", "butterflyShot", "lightShot", "silverKnife_Red"
	};

	//各弾の弾速。
	public static final float speed[] =
	{
		0.6F, 0.6F, 0.5F, 0.3F, 0.6F, 0.6F, 0.6F, 0.65F, 0.3F, 0.5F, 0.8F
	};

	//各弾IDの形状
	public static final int form[] =
	{
		thShotLib.SMALL[0]    , thShotLib.TINY[0]     , thShotLib.MEDIUM[0], thShotLib.BIG[0]  , 
		thShotLib.STAR[0]     , thShotLib.SMALLSTAR[0], thShotLib.CIRCLE[0], thShotLib.SCALE[0],
		thShotLib.BUTTERFLY[0], thShotLib.LIGHT[0], thShotLib.KNIFE[0]
	};
	
	@SideOnly(Side.CLIENT)
    private Icon[] icon;

	public ItemTHShot(int itemID)
	{
		super(itemID);
		setHasSubtypes(true);
		setMaxDamage(0);
		setCreativeTab(CreativeTabs.tabMaterials);//クリエイティブの素材タブに登録
	}
	
	public String getUnlocalizedName(ItemStack itemStack)
    {
        int i = MathHelper.clamp_int(itemStack.getItemDamage(), 0, 15);
        return super.getUnlocalizedName() + "." + shotNames[i];
    }
	
	@SideOnly(Side.CLIENT)
	//ダメージ値によってアイテムアイコンを変える
    public Icon getIconFromDamage(int damage)
    {
        int i = MathHelper.clamp_int(damage, 0, shotNames.length);
        return this.icon[i];
    }
	
	@SideOnly(Side.CLIENT)
    public void registerIcons(IconRegister par1IconRegister)
    {
        this.icon = new Icon[shotIconName.length];

        for (int i = 0; i < shotIconName.length; ++i)
        {
            this.icon[i] = par1IconRegister.registerIcon(shotIconName[i]);
        }
    }
	
	//右クリックを押したときの処理
	public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer entityPlayer)
	{
		EntityTHShot entityTHShot;
		double vectorX, vectorY, vectorZ;
		Random rand = new Random();
		int type = itemStack.getItemDamage();
		int type2 = form[type] / 8;//IDの互換用
		int color = form[type] + rand.nextInt(7);
		int sellectbleColor[] = {7, 0, 2, 0, 1, 4, 5, 7, 7, 4, 2, 3, 5, 4, 6, 7};//１６色の染料を８色に対応させるための配列
		ItemStack colorItem = entityPlayer.inventory.mainInventory[entityPlayer.inventory.currentItem + 1];//右横に持っている相手っ無を取得
		if(entityPlayer.inventory.currentItem < 8 && colorItem != null)//右横にアイテムがあるなら
    	{
    		if(colorItem.itemID == Item.dyePowder.itemID)//そのアイテムが染料なら
    		{
    			//染料のダメージ値を取得
    			color = form[type] + sellectbleColor[entityPlayer.inventory.mainInventory[entityPlayer.inventory.currentItem + 1].getItemDamage()];
    		}
    	}
		int deadTime = 60;
		vectorX = -Math.sin(entityPlayer.rotationYaw / 180F * 3.141593F) * Math.cos(entityPlayer.rotationPitch / 180F * 3.141593F);
		vectorY = -Math.sin(entityPlayer.rotationPitch / 180F * 3.141593F);
		vectorZ =  Math.cos(entityPlayer.rotationYaw / 180F * 3.141593F) * Math.cos(entityPlayer.rotationPitch / 180F * 3.141593F);
		entityTHShot = new EntityTHShot( world, entityPlayer, entityPlayer, entityPlayer.posX, entityPlayer.posY, entityPlayer.posZ,
			vectorX, vectorY, vectorZ,
			speed[type] * 0.5D, speed[type], speed[type] * 0.2D, 0.0D, 0.0D, 0.0D, 
			thShotLib.DAMAGE[type2], color, thShotLib.SIZE[type2], deadTime);
		if(!world.isRemote)
		{
			world.spawnEntityInWorld(entityTHShot);
			itemStack.stackSize --;
		}
		
		return itemStack;
	}

	
	@SideOnly(Side.CLIENT)
	//クリエイトモードのアイテム欄に、ダメージ値の違うアイテムも表示できるようにする
    public void getSubItems(int par1, CreativeTabs par2CreativeTabs, List par3List)
    {
        for (int i = 0; i < shotNames.length; i++)
        {
            par3List.add(new ItemStack(par1, 1, i));
        }
    }
	
}