package net.minecraft.thKaguyaMod.client;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.util.ResourceLocation;
import net.minecraft.client.model.ModelBase;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

import org.lwjgl.opengl.GL11;

import net.minecraft.thKaguyaMod.*;

@SideOnly(Side.CLIENT)
public class RenderMarisaBroom extends Render
{
    //魔理沙の箒を描画
	private static final ResourceLocation field_110782_f = new ResourceLocation("/item/boat.png");
    protected ModelBase modelMarisaBroom;

    public RenderMarisaBroom()
    {
        this.shadowSize = 0.5F;
        this.modelMarisaBroom = new ModelMarisaBroom();
    }

    /**
     * The render method used in RenderBoat that renders the boat model.
     */
    public void renderMarisaBroom(EntityMarisaBroom entityMarisaBroom, double x, double y, double z, float par8, float par9)
    {
        GL11.glPushMatrix();
        GL11.glTranslatef((float)x, (float)y, (float)z);
        GL11.glRotatef(180.0F - par8, 0.0F, 1.0F, 0.0F);
        float f2 = (float)entityMarisaBroom.getTimeSinceHit() - par9;
        float f3 = (float)entityMarisaBroom.getDamageTaken() - par9;

        if (f3 < 0.0F)
        {
            f3 = 0.0F;
        }

        if (f2 > 0.0F)
        {
            GL11.glRotatef(MathHelper.sin(f2) * f2 * f3 / 10.0F * (float)entityMarisaBroom.getForwardDirection(), 1.0F, 0.0F, 0.0F);
        }

        //this.loadTexture("/terrain.png");
        float size = 0.75F;
        GL11.glScalef(size, size, size);
        GL11.glScalef(1.0F / size, 1.0F / size, 1.0F / size);
        //this.loadTexture("/item/boat.png");
        GL11.glScalef(-1.0F, -1.0F, 1.0F);
        this.modelMarisaBroom.render(entityMarisaBroom, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
        GL11.glPopMatrix();
    }
    
    protected ResourceLocation func_110781_a(EntityMarisaBroom entityMarisaBroom)
    {
        return field_110782_f;
    }

    protected ResourceLocation func_110775_a(Entity entity)
    {
        return this.func_110781_a((EntityMarisaBroom)entity);
    }

    /**
     * Actually renders the given argument. This is a synthetic bridge method, always casting down its argument and then
     * handing it off to a worker function which does the actual work. In all probabilty, the class Render is generic
     * (Render<T extends Entity) and this method has signature public void doRender(T entity, double d, double d1,
     * double d2, float f, float f1). But JAD is pre 1.5 so doesn't do that.
     */
    public void doRender(Entity entity, double x, double y, double z, float par8, float par9)
    {
        this.renderMarisaBroom((EntityMarisaBroom)entity, x, y, z, par8, par9);
    }
}
