package net.minecraft.thKaguyaMod.client;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.util.ResourceLocation;
import net.minecraft.client.model.ModelBase;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;
import net.minecraft.thKaguyaMod.*;

import java.util.Random;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;

@SideOnly(Side.CLIENT)
public class RenderTHShot extends Render
{
	
	//弾の描画
	private static final ResourceLocation resourceLocation_Normal = new ResourceLocation("textures/Shot.png");
	private static final ResourceLocation resourceLocation_Butterfly = new ResourceLocation("textures/ButterflyShot.png");
	private static final ResourceLocation resourceLocation_Star = new ResourceLocation("textures/StarShot.png");
	private static final ResourceLocation resourceLocation_Scale = new ResourceLocation("textures/ScaleShot.png");
	private static final ResourceLocation resourceLocation_Wind = new ResourceLocation("textures/Wind.png");
	private static final ResourceLocation resourceLocation_Knife_Blue = new ResourceLocation("textures/SilverKnife_Blue.png");
	private static final ResourceLocation resourceLocation_Knife_Red = new ResourceLocation("textures/SilverKnife_Red.png");
	private static final ResourceLocation resourceLocation_Knife_Green = new ResourceLocation("textures/SilverKnife_Green.png");
	private static final ResourceLocation resourceLocation_Knife_White= new ResourceLocation("textures/SilverKnife_White.png");
	private static final ResourceLocation resourceLocation_Light= new ResourceLocation("textures/MusouFuuin.png");
	
	
	private Random random = new Random();
	float colorR[] = { 255F,   0F,   0F, 255F, 255F,   0F, 255F, 255F};
    float colorG[] = {   0F,   0F, 255F, 255F,   0F, 255F, 165F, 255F};
    float colorB[] = {   0F, 255F,   0F,   0F, 255F, 255F,   0F, 255F};

    public RenderTHShot()
    {
    }

    public void doRenderTHShot(EntityTHShot entityTHShot, double x, double y, double z,
            float yaw, float f1)
    {
        GL11.glPushMatrix();
        func_110777_b(entityTHShot);
        GL11.glTranslatef((float)x, (float)y, (float)z);
    	GL11.glDisable(GL11.GL_LIGHTING);
    	GL11.glEnable(GL11.GL_NORMALIZE);
    	GL11.glEnable(GL11.GL_BLEND);
    	GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE_MINUS_SRC_COLOR);
    	GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
    	float size = entityTHShot.getShotSize();
    	float size2;
        Tessellator tessellator = Tessellator.instance;
    	int color = entityTHShot.getShotColor();
    	//粒弾、小弾、中弾、大弾、輪弾の描画
    	if(color <= thShotLib.CIRCLE[7] || (color >= thShotLib.BIG[0] && color <= thShotLib.BIG[7]))
    	{
    		GL11.glScalef(size, size, size);
    		if(color >= thShotLib.BIG[0])
    		{
    			size2 = size * 1.5F;
    			GL11.glScalef(size2, size2, size2);
    		}
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		renderNormalShot(tessellator, color);
    	}
    	//光弾の描画
    	else if(color <= thShotLib.LIGHT[7])
    	{
    		GL11.glScalef(size, size, size);
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		int count = entityTHShot.ticksExisted % 2;
    		renderLightShot(tessellator, color, entityTHShot);
    	}
    	//鱗弾の描画
    	else if(color <= thShotLib.SCALE[7])
    	{
    		GL11.glScalef(size, size, size);
    		float pitch = entityTHShot.rotationPitch;
    		if(pitch > 90F)
    		{
    			pitch = 90F - pitch % 90F;
    		}
    		else if(pitch < -90F)
    		{
    			pitch = -90F - pitch % 90F;
    		}
    		GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
    		GL11.glRotatef(-pitch, 1.0F, 0.0F, 0.0F);
    		renderScaleShot(tessellator, color);
    		GL11.glPopMatrix();//行列を元に戻す
    		
    		GL11.glPushMatrix();
    		GL11.glTranslatef((float)x, (float)y, (float)z);
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		float size3 = size * 0.9F;
    		GL11.glScalef(size3, size3, size3);
    		
			float f3 = 0.5F;
	        float f4 = 1.0F;
	        float f5 = 0.0F;
	        float f6 = 1.0F;
	        float f7 = 1.0F;
	        float f8 = 0.5F;
	        float f9 = 0.25F;
	        tessellator.startDrawingQuads();
	        tessellator.setNormal(0.0F, 1.0F, 0.0F);
	        tessellator.addVertexWithUV(0.0F - f8, 0.0F - f9, 0.0D, f3, f6);
	        tessellator.addVertexWithUV(f7 - f8, 0.0F - f9, 0.0D, f4, f6);
	        tessellator.addVertexWithUV(f7 - f8, 1.0F - f9, 0.0D, f4, f5);
	        tessellator.addVertexWithUV(0.0F - f8, 1.0F - f9, 0.0D, f3, f5);
			tessellator.draw();
			
    		//renderNormalShot(tessellator, color % 8);
    	}
    	//蝶弾の描画
    	else if(color <= thShotLib.BUTTERFLY[7])
    	{
    		size2 = size * 2.0F;
    		GL11.glScalef(size2, size2, size2);
    		float wingAngle = MathHelper.sin((float)entityTHShot.ticksExisted / 3.0F) * 45F;
    		float pitch = entityTHShot.rotationPitch;
    		if(pitch > 90F)
    		{
    			pitch = 90F - pitch % 90F;
    		}
    		else if(pitch < -90F)
    		{
    			pitch = -90F - pitch % 90F;
    		}
    		GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
    		GL11.glRotatef(-pitch, 1.0F, 0.0F, 0.0F);
    		GL11.glRotatef(wingAngle, 0.0F, 0.0F, 1.0F);
    		renderButterflyShot(tessellator, color, wingAngle);
    	}
    	//星弾の描画
    	else if(color <= thShotLib.STAR[7])
    	{
    		GL11.glScalef(size, size, size);
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		GL11.glRotatef((float)entityTHShot.ticksExisted * 3.7F, 0.0F, 0.0F, 1.0F);
    		renderStarShot(tessellator, color);
    	}
    	else if(color <= thShotLib.RICE[7])
    	{
    		float sizeX = size * 2F + MathHelper.sin((entityTHShot.rotationYaw - renderManager.playerViewX) / 180F * 3.141593F) * size;
    		//float sizeZ = size * 2F + MathHelper.cos((entityTHShot.rotationPitch - renderManager.playerViewX) / 180F * 3.141593F) * size;
    		float sizeY = size * 2F + MathHelper.sin((entityTHShot.rotationPitch - renderManager.playerViewY) / 180F * 3.141593F) * size;
    		GL11.glScalef(sizeX, sizeY, size);
    		if(color >= thShotLib.BIG[0])
    		{
    			size2 = size * 1.5F;
    			GL11.glScalef(size2, size2, size2);
    		}
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		//GL11.glRotatef(-yaw, 0.0F, 1.0F, 0.0F);
    		//GL11.glRotatef(entityTHShot.rotationPitch, 1.0F, 0.0F, 0.0F);
    		color %= 8;
    		renderNormalShot(tessellator, color);
    	}
    	else if(color <= thShotLib.KNIFE[7])
    	{
    		size2 = size * 1.5F;
    		GL11.glScalef(size, size2, size2);
    		ModelBase modelSilverKnife;
    		modelSilverKnife = new ModelSilverKnife();
    		GL11.glRotatef( yaw,   0F, 1F, 0F);
    		GL11.glRotatef(-entityTHShot.rotationPitch, 1F, 0F, 0F);
    		//GL11.glRotatef( entityTHShot.getKnifeZAngle(), 0F, 0F, 1F);
    		switch(color % 8)
    		{
    			case 0:
        			//loadTexture("/textures/SilverKnifeTexture2.png");
    				break;
    			case 1:
    				//loadTexture("/textures/SilverKnifeTexture.png");
    				break;
    			case 2:
    				//loadTexture("/textures/SilverKnifeTexture3.png");
    				break;
    			default:
    				//loadTexture("/textures/SilverKnifeTexture4.png");
    				break;
    		}
    		modelSilverKnife.render(entityTHShot, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
    	}
    	else if(color <= thShotLib.WIND[7])
    	{
    		size2 = size * 0.5F;
    		GL11.glScalef(size2, size2, size2);
    		renderWindShot(tessellator, color, entityTHShot);
    	}
    	else
    	{

    		GL11.glScalef(size, size, size);
    		GL11.glRotatef(180F - renderManager.playerViewY, 0.0F, 1.0F, 0.0F);
        	GL11.glRotatef(-renderManager.playerViewX, 1.0F, 0.0F, 0.0F);
    		int count = entityTHShot.ticksExisted % 2;
    		renderKishituShot(tessellator, color, entityTHShot);
    	}

        GL11.glDisable(GL11.GL_BLEND);
        GL11.glEnable(GL11.GL_LIGHTING);
        GL11.glPopMatrix();
    }
	
	//円形弾の描画
	public void renderNormalShot(Tessellator tessellator, int color)
	{
		//loadTexture("/textures/Shot.png");
		if(color >= thShotLib.BIG[0])
		{
			float f3 = (float)((color % 16) * 32 +  0) / 256F;
	        float f4 = (float)((color % 16) * 32 + 32) / 256F;
	        float f5 = (float)((color / 16) * 32 +  0) / 256F;
	        float f6 = (float)((color / 16) * 32 + 32) / 256F;
	        float f7 = 1.0F;
	        float f8 = 0.5F;
	        float f9 = 0.25F;
	        tessellator.startDrawingQuads();
	        tessellator.setNormal(0.0F, 1.0F, 0.0F);
	        tessellator.addVertexWithUV(0.0F - f8, 0.0F - f9, 0.0D, f3, f6);
	        tessellator.addVertexWithUV(f7 - f8, 0.0F - f9, 0.0D, f4, f6);
	        tessellator.addVertexWithUV(f7 - f8, 1.0F - f9, 0.0D, f4, f5);
	        tessellator.addVertexWithUV(0.0F - f8, 1.0F - f9, 0.0D, f3, f5);
			tessellator.draw();
		}
		else
		{
			float f3 = (float)((color % 16) * 16 +  0) / 256F;
	        float f4 = (float)((color % 16) * 16 + 16) / 256F;
	        float f5 = (float)((color / 16) * 16 +  0) / 256F;
	        float f6 = (float)((color / 16) * 16 + 16) / 256F;
	        float f7 = 1.0F;
	        float f8 = 0.5F;
	        float f9 = 0.25F;
	        tessellator.startDrawingQuads();
	        tessellator.setNormal(0.0F, 1.0F, 0.0F);
	        tessellator.addVertexWithUV(0.0F - f8, 0.0F - f9, 0.0D, f3, f6);
	        tessellator.addVertexWithUV(f7 - f8, 0.0F - f9, 0.0D, f4, f6);
	        tessellator.addVertexWithUV(f7 - f8, 1.0F - f9, 0.0D, f4, f5);
	        tessellator.addVertexWithUV(0.0F - f8, 1.0F - f9, 0.0D, f3, f5);
			tessellator.draw();
		}
	}
	
	//光の弾の描画
	public void renderLightShot(Tessellator tessellator, int color, EntityTHShot entityTHShot)
	{
		//loadTexture("/textures/MusouFuuin.png");
		color %= 8;
		int count = entityTHShot.ticksExisted % 2;
		float uMin = (float)(count * 32 +  0) / 64F;
	    float uMax = (float)(count * 32 + 32) / 64F;
	    float vMin = 0F;
	    float vMax = 1F;
		float width = 1.0F;

	    tessellator.startDrawingQuads();
	    tessellator.setNormal(0.0F, 1.0F, 0.0F);
		tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 0.5F);
	    tessellator.addVertexWithUV(-width, -width, 0.0D, uMin, vMax);
	    tessellator.addVertexWithUV( width, -width, 0.0D, uMax, vMax);
	    tessellator.addVertexWithUV( width,  width, 0.0D, uMax, vMin);
	    tessellator.addVertexWithUV(-width,  width, 0.0D, uMin, vMin);
		tessellator.draw();

		width = 0.5F;
		tessellator.startDrawingQuads();
	    tessellator.setNormal(0.0F, 1.0F, 0.0F);
		tessellator.setColorRGBA_F(1F, 1F, 1F, 0.8F);
	    tessellator.addVertexWithUV(-width, -width, 0.01D, uMin, vMax);
	    tessellator.addVertexWithUV( width, -width, 0.01D, uMax, vMax);
	    tessellator.addVertexWithUV( width,  width, 0.01D, uMax, vMin);
	    tessellator.addVertexWithUV(-width,  width, 0.01D, uMin, vMin);
		tessellator.draw();

	}
	
	//気質弾の描画
	public void renderKishituShot(Tessellator tessellator, int color, EntityTHShot entityTHShot)
	{
		//loadTexture("/textures/MusouFuuin.png");
		color %= 8;
		int count = entityTHShot.ticksExisted % 2;
		float uMin = (float)(count * 32 +  0) / 64F;
	    float uMax = (float)(count * 32 + 32) / 64F;
	    float vMin = 0F;
	    float vMax = 1F;
		float width = 1.0F;

	    tessellator.startDrawingQuads();
	    tessellator.setNormal(0.0F, 1.0F, 0.0F);
		tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 0.5F);
	    tessellator.addVertexWithUV(-width, -width, 0.0D, uMin, vMax);
	    tessellator.addVertexWithUV( width, -width, 0.0D, uMax, vMax);
	    tessellator.addVertexWithUV( width,  width, 0.0D, uMax, vMin);
	    tessellator.addVertexWithUV(-width,  width, 0.0D, uMin, vMin);
		tessellator.draw();

		width = 0.8F;
		tessellator.startDrawingQuads();
	    tessellator.setNormal(0.0F, 1.0F, 0.0F);
		tessellator.setColorRGBA_F(1F, 1F, 1F, 0.8F);
	    tessellator.addVertexWithUV(-width, -width, 0.01D, uMin, vMax);
	    tessellator.addVertexWithUV( width, -width, 0.01D, uMax, vMax);
	    tessellator.addVertexWithUV( width,  width, 0.01D, uMax, vMin);
	    tessellator.addVertexWithUV(-width,  width, 0.01D, uMin, vMin);
		tessellator.draw();

	}
	
	//光のエフェクト
	public void renderLightEffect(Tessellator tessellator, int color, float size, EntityTHShot entityTHShot)
	{
		//loadTexture("/textures/MusouFuuin.png");
		color %= 8;
		int count = entityTHShot.ticksExisted % 2;
		//float size = entityTHShot.getShotSize();
		float f3 = (float)(count * 32 +  0) / 64F;
	    float f4 = (float)(count * 32 + 32) / 64F;
	    float f5 = 0F;
	    float f6 = 1F;
	    float f7 = 1.0F;
	    float f8 = 0.5F;
	    float f9 = 0.25F;
		GL11.glScalef(size, size, size);
	    tessellator.startDrawingQuads();
	    tessellator.setNormal(0.0F, 1.0F, 0.0F);
		tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 0.5F);
	    tessellator.addVertexWithUV(0.0F - f8, 0.0F - f9, 0.0D, f3, f6);
	    tessellator.addVertexWithUV(f7 - f8, 0.0F - f9, 0.0D, f4, f6);
	    tessellator.addVertexWithUV(f7 - f8, 1.0F - f9, 0.0D, f4, f5);
	    tessellator.addVertexWithUV(0.0F - f8, 1.0F - f9, 0.0D, f3, f5);
		tessellator.draw();
	}
	
	//鱗弾の描画
	public void renderScaleShot(Tessellator tessellator, int color)
	{
		GL11.glDisable(GL11.GL_CULL_FACE);//両面描画
		color %= 8;
		//loadTexture("/textures/ScaleShot.png");
    	float xLength = 0.75F;
    	double zLength = 0.75F;
    	float uMin = 0.0F;
    	float uMax = 0.5F;
    	float vMin = 0.0F;
    	float vMax = 1.0F;
    	tessellator.startDrawingQuads();  
    	tessellator.setNormal(0.0F, 1.0F, 0.0F);
    	tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 0.8F);
        tessellator.addVertexWithUV(-xLength, 0.1F,  zLength + 0.15F, uMin, vMin);
        tessellator.addVertexWithUV( xLength, 0.1F,  zLength + 0.15F, uMax, vMin);
        tessellator.addVertexWithUV( xLength, 0.1F, -zLength + 0.15F, uMax, vMax);
        tessellator.addVertexWithUV(-xLength, 0.1F, -zLength + 0.15F, uMin, vMax);
		tessellator.draw();
		GL11.glEnable(GL11.GL_CULL_FACE);//表綿描画
	}
	
	//蝶弾
	public void renderButterflyShot(Tessellator tessellator, int color, float wingAngle)
	{
		GL11.glDisable(GL11.GL_CULL_FACE);//両面描画
		color %= 8;
		//loadTexture("/textures/ButterflyShot2.png");
		float minU =  0F / 128F;
        float maxU = 32F / 128F;
        float minV = 0F;
        float maxV = 1F;

	    	tessellator.startDrawingQuads();
    		tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 1.0F);
	        tessellator.addVertexWithUV(0.0F, 0.0F,  0.5D, maxU, minV);
	        tessellator.addVertexWithUV(0.5F, 0.0F,  0.5D, minU, minV);
	        tessellator.addVertexWithUV(0.5F, 0.0F, -0.5D, minU, maxV);
	        tessellator.addVertexWithUV(0.0F, 0.0F, -0.5D, maxU, maxV);
	        tessellator.draw();	
			tessellator.startDrawingQuads();
    		tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, 0.4F);
	        tessellator.addVertexWithUV(0.0F , 0.000F,  0.45D, maxU, minV);
	        tessellator.addVertexWithUV(0.45F, 0.000F,  0.45D, minU, minV);
	        tessellator.addVertexWithUV(0.45F, 0.000F, -0.45D, minU, maxV);
	        tessellator.addVertexWithUV(0.0F , 0.000F, -0.45D, maxU, maxV);
	        tessellator.draw();	
    	GL11.glRotatef(-wingAngle * 2F, 0.0F, 0.0F, 1.0F);

	    	tessellator.startDrawingQuads();
    		tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(colorR[color]/255F, colorG[color]/255F, colorB[color]/255F, 1.0F);
	    	tessellator.addVertexWithUV( 0.0F, 0.0F,  0.5D, maxU, minV);
	    	tessellator.addVertexWithUV(-0.5F, 0.0F,  0.5D, minU, minV);
	    	tessellator.addVertexWithUV(-0.5F, 0.0F, -0.5D, minU, maxV);
	    	tessellator.addVertexWithUV( 0.0F, 0.0F, -0.5D, maxU, maxV);
	    	tessellator.draw();
			tessellator.startDrawingQuads();
    		tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, 0.4F);
	    	tessellator.addVertexWithUV( 0.0F , 0.000F,  0.45D, maxU, minV);
	    	tessellator.addVertexWithUV(-0.45F, 0.000F,  0.45D, minU, minV);
	    	tessellator.addVertexWithUV(-0.45F, 0.000F, -0.45D, minU, maxV);
	    	tessellator.addVertexWithUV( 0.0F , 0.000F, -0.45D, maxU, maxV);
	    	tessellator.draw();
		GL11.glEnable(GL11.GL_CULL_FACE);//表綿描画
	}

	//星弾の描画
	public void renderStarShot(Tessellator tessellator, int color)
	{
		//loadTexture("/textures/StarShot.png");
		color %= 8;
		float[] topPointX = new float[11];
		float[] topPointY = new float[11];
		float angle = 0F;
		float spanAngle = (float)Math.PI * 0.2F;//36°
		for(int i = 0; i < 10; i+=2)
		{
			topPointX[i] = (float)Math.cos(angle);
			topPointY[i] = (float)Math.sin(angle);
			angle += spanAngle;
			topPointX[i+1] = (float)Math.cos(angle) * 0.6F;
			topPointY[i+1] = (float)Math.sin(angle) * 0.6F;
			angle += spanAngle;
		}
		topPointX[10] = topPointX[0];
		topPointY[10] = topPointY[0];
		for(int i = 0; i < 9; i+=2)
		{
			//星の枠部
			tessellator.startDrawingQuads();
        	tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(colorR[color], colorG[color], colorB[color], 0.7F);
        	tessellator.addVertexWithUV(topPointX[i]  , topPointY[i]  , 0.0D, 0F, 0F);
        	tessellator.addVertexWithUV(topPointX[i+1], topPointY[i+1], 0.0D, 1F, 0F);
        	tessellator.addVertexWithUV(topPointX[i+2], topPointY[i+2], 0.0D, 1F, 1F);
			tessellator.addVertexWithUV(          0.0F,           0.0F, 0.1D, 0F, 1F);
			tessellator.draw();
			//星の中心部　白い
			tessellator.startDrawingQuads();
        	tessellator.setNormal(0.0F, 1.0F, 0.0F);
			tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, 0.7F);
			tessellator.addVertexWithUV(topPointX[i]   * 0.7F, topPointY[i]   * 0.7F,  0.0D, 0F, 0F);
			tessellator.addVertexWithUV(topPointX[i+1] * 0.95F, topPointY[i+1] * 0.95F,  0.0D, 1F, 0F);
        	tessellator.addVertexWithUV(topPointX[i+2] * 0.7F, topPointY[i+2] * 0.7F,  0.0D, 1F, 1F);
			tessellator.addVertexWithUV(          0.0F,           0.0F, 0.21D, 0F, 1F);
			tessellator.draw();
		}
	}
	
	//風弾の描画
	public void renderWindShot(Tessellator tessellator, int color, EntityTHShot entityTHShot)
	{
		//loadTexture("/textures/SanaeWind.png");

		color %= 8;
    	Random random = new Random();
    	float rand1 = (float)random.nextInt(50) / 100F;
    	float rand2 = (float)random.nextInt(100) / 100F;
    	int pattern = entityTHShot.ticksExisted % 4;
        float f3 = (float)((pattern % 2) * 32 + 0) / 64F;
        float f4 = (float)((pattern % 2) * 32 + 32) / 64F;
        float f5 = (float)((int)(pattern / 2) * 16 + 0) / 32F;
        float f6 = (float)((int)(pattern / 2) * 16 + 16) / 32F;
    	float f7 = rand1;
    	float f8 = 4.0F + rand2;
        float f9 = 0.5F;

		GL11.glDisable(GL11.GL_CULL_FACE);//両面描画
    	for(int i = 0; i < 8; i++)
    	{
    		GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
	        tessellator.startDrawingQuads();
    		tessellator.setNormal(0.0F, 1.0F, 0.0F);
	    	tessellator.setColorRGBA_F(colorR[color], colorG[color], colorB[color], 0.3F);
	        tessellator.addVertexWithUV(0.0F - f7, -1.0F - f9, 0.0D, f3, f6);
	        tessellator.addVertexWithUV(0.0F + f7, -1.0F - f9, 0.0D, f4, f6);
	        tessellator.addVertexWithUV(0.0F + f8,  2.0F - f9, 2.0D, f4, f5);
	        tessellator.addVertexWithUV(0.0F - f8,  2.0F - f9, 2.0D, f3, f5);
			tessellator.draw();
    	}
		GL11.glEnable(GL11.GL_CULL_FACE);//表面描画
	}
	
    protected ResourceLocation func_110781_a(EntityTHShot entityTHShot)
    {
    	int color = entityTHShot.getShotColor();
    	
    	if(color <= thShotLib.CIRCLE[7] || (color >= thShotLib.BIG[0] && color <= thShotLib.BIG[7]))
    	{
    		return resourceLocation_Normal;
    	}
    	//光弾の描画
    	else if(color <= thShotLib.LIGHT[7])
    	{
    		return resourceLocation_Light;
    	}
    	//鱗弾の描画
    	else if(color <= thShotLib.SCALE[7])
    	{
    		return resourceLocation_Scale;
    	}
    	//蝶弾の描画
    	else if(color <= thShotLib.BUTTERFLY[7])
    	{
    		return resourceLocation_Butterfly;
    	}
    	//星弾の描画
    	else if(color <= thShotLib.STAR[7])
    	{
    		return resourceLocation_Star;
    	}
    	else if(color <= thShotLib.RICE[7])
    	{
    		return resourceLocation_Normal;
    	}
    	else if(color <= thShotLib.KNIFE[7])
    	{
    		switch(color % 8)
    		{
    			case 0:
        			return resourceLocation_Knife_Red;
    			case 1:
    				return resourceLocation_Knife_Blue;
    			case 2:
    				return resourceLocation_Knife_Green;
    			default:
    				return resourceLocation_Knife_White;
    		}
    	}
    	else if(color <= thShotLib.WIND[7])
    	{
    		return resourceLocation_Wind;
    	}
    	else
    	{
    		return resourceLocation_Light;
    	}
    }

    protected ResourceLocation func_110775_a(Entity entity)
    {
        return this.func_110781_a((EntityTHShot)entity);
    }
	
    public void doRender(Entity entity, double d, double d1, double d2,
            float f, float f1)
    {
        doRenderTHShot((EntityTHShot)entity, d, d1, d2, f, f1);
    }
}
